
var GTDGmail_ComposeScreen = {
	signiture: "",

	pageHasFreshComposeDetails: function(){
		var ElFrom = document.getElementById("6row_compose");
				
		if( ElFrom ){
			//alert("ho");
			return true;
		}else{
			return false;
		}	
	},
	
	handleCompose: function(){
		/*
			Inject the box into the Compose screen, right at the top
				Send Email - Send Task to Myself - Send Reference to Myself
			
			If Task/Reference label is missing, do not link, and add [Requires Label 'T:To Do']
		*/	
		
		try{
			if( !document.getElementById("GTDCompose_Selection") ){
				var ElSelection = document.createElement("DIV");
				ElSelection.id = "GTDCompose_Selection";
				ElSelection.className = "GTDCompose_Selection";
				
				var innerHTML = "";
				innerHTML += "<a id='GTDCompose_SendEmail' href='' style='font-weight:bold;' onclick=\"GTDGmail_ComposeScreen.clickHandler_SendEmail();return false;\" >Compose Email</a>&nbsp;-&nbsp;";
				
				// Test for default To Do:
				//if( GTDGmail_Common.testLabelInUse("ToDo", GTDGmail_Common.SharedObj.StandardLabels.ToDo) ){
					// Has it
					innerHTML += "<a id='GTDCompose_SendTask' href='' onclick=\"GTDGmail_ComposeScreen.clickHandler_SendMyselfTask();return false;\" >Compose Myself a Task</a>&nbsp;-&nbsp;";
				//}else{
					// Doesn't have it
				//	innerHTML += "<span>Send Myself a Task [Requires Label <i>" + GTDGmail_Common.SharedObj.StandardLabels.ToDo + "</i>]&nbsp;-&nbsp;</span>";
				//}
				
				// Test for default Reference:
				//if( GTDGmail_Common.testLabelInUse("Reference", GTDGmail_Common.SharedObj.StandardLabels.Reference) ){
					// Has it
					innerHTML += "<a id='GTDCompose_SendReference' href='' onclick=\"GTDGmail_ComposeScreen.clickHandler_SendMyselfReference();return false;\" >Compose Myself a Reference</a>";
				//}else{
					// Doesn't have it
				//	innerHTML += "<span>Send Myself a Task [Requires Label <i>" + GTDGmail_Common.SharedObj.StandardLabels.Reference + "</i>]</span>";
				//}
				
				innerHTML += "<div id='GTDCompose_Selection_Info' class='GTDCompose_Selection_Info'>Sending yourself a Task and Reference requires you to have appropriate filters set up. See <a href='http://www.gtdgmail.com/help/recommended_filters/' target='_blank'>Task/Reference Filter Help</a>&nbsp;<a id='GTDComposeSelectionInfo' href='' onclick=\"GTDGmail_Common.clickHandler_ShowHide(this, false);return false;\" next='hide' elToShowHide='GTDCompose_Selection_Info' textShow='' textHide='[Hide]' class='' >[Hide Forever]</a></div>";
				
				ElSelection.innerHTML = innerHTML;
				
				// Hook it in
				var ElHook = document.getElementById("cmh_compose");
				ElHook.parentNode.insertBefore( ElSelection, ElHook );
				
				// Hide anything that needs to be:
				GTDGmail_Common.hideShowHideElements();
				
				
				if( GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.Conversation.SendMyselfTaskFirst", false) ){
					// Simulate a click on "Send Myself a Task"
					this.clickHandler_SendMyselfTask();
				}
			}

		}catch(e){
			//alert(e.toString() + "\nGTDGmail_ComposeScreen");
		}
		
	
	},
	
	unboldenSelection: function(){
		var SelectionIdArray = ["GTDCompose_SendEmail", "GTDCompose_SendTask", "GTDCompose_SendReference"];
				
		for( var i = 0; i < SelectionIdArray.length; i++ ){
			var El = document.getElementById( SelectionIdArray[i] );
			El.style.fontWeight = "";
		}
	},
	
	clickHandler_SendEmail: function(){
		try{
			// Unbolden everything:
			this.unboldenSelection();
					
			// Make it bold
			var ElSendEmail = document.getElementById("GTDCompose_SendEmail");
			ElSendEmail.style.fontWeight = "bold";
			
			// Make the To field blank
			var ElTo = document.getElementById("to_compose");
			ElTo.value = "";
			
			this.showHideElements("show");
		}catch(e){
			//alert(e.toString() + "\nGTDGmail_ComposeScreen");
		}
		
	},
	
	clickHandler_SendMyselfTask: function(){
		try{
			// Unbolden everything:
			this.unboldenSelection();
					
			// Make it bold
			var ElSendEmail = document.getElementById("GTDCompose_SendTask");
			ElSendEmail.style.fontWeight = "bold";
			
			// Make the To field blank
			var ElTo = document.getElementById("to_compose");
			ElTo.value = GTDGmail_Common.SharedObj.Options.getOption("char", "CurrentEmailAddress", "").replace("@", "+Task@");
			
			this.showHideElements("hide");
			
			// Focus on Subject
			document.getElementById("3row_compose").lastChild.lastChild.focus();
		}catch(e){
			//alert(e.toString() + "\nGTDGmail_ComposeScreen");
		}
		
	},
	clickHandler_SendMyselfReference: function(){
		try{
			// Unbolden everything:
			this.unboldenSelection();
					
			// Make it bold
			var ElSendEmail = document.getElementById("GTDCompose_SendReference");
			ElSendEmail.style.fontWeight = "bold";
			
			// Make the To field blank
			var ElTo = document.getElementById("to_compose");
			ElTo.value = GTDGmail_Common.SharedObj.Options.getOption("char", "CurrentEmailAddress", "").replace("@", "+Reference@");
			
			this.showHideElements("hide");
			
			// Focus on Subject
			document.getElementById("3row_compose").lastChild.lastChild.focus();
		}catch(e){
			//alert(e.toString() + "\nGTDGmail_ComposeScreen");
		}
		
	},
	
	showHideElements: function(showHide){
		/*
			Set style.display to Show/Hide the elements in GTDGmail_Common.SharedObj.Compose.ShowHideElArray
			i.e. the From and To box
		*/
		
		
		var ElArray = null;
		if( showHide=="show" ){
			// Show
			ElArray = GTDGmail_Common.SharedObj.Compose.ShowElArray;
		
			for( var i = 0; i < ElArray.length; i++ ){
				var El = document.getElementById( ElArray[i] );
				if( El ){
					if( El.getAttribute("wasShown")=="yes" ){
						// It was formerly show, so make it shown again:
						El.style.display = "";
						El.setAttribute("wasShown", "");
					}
				}
			}	
		}else{
			// Hide
			ElArray = GTDGmail_Common.SharedObj.Compose.HideElArray;
			
			for( var i = 0; i < ElArray.length; i++ ){
				var El = document.getElementById( ElArray[i] );
				if( El ){
					if( El.style.display!="none" ){
						El.style.display = "none";
						El.setAttribute("wasShown", "yes");
					}
				}
			}	
		}

	},
}

