
var GTDGmail_LabelsAdmin = {
	
	pageHasLabelsAdmin: function(){
		var ElLabelTextBox = document.getElementById("l");
		var ElCreateButton = document.getElementById("plb");
		
		if( ElLabelTextBox && ElCreateButton ){
			
			return true;
		}else{
			return false;
		}
	},
	
	handleLabelsAdmin: function(){


		try{
			var ElHookPoint = document.getElementById("l");

			if( !document.getElementById("GTDLabelsAdminBox") ){
				var ElLabelsBox = document.createElement("DIV");
				ElLabelsBox.id = "GTDLabelsAdminBox";
				ElLabelsBox.className = "GTDLabelsAdminBox";
				
				// Add it:
				ElHookPoint.appendChild(ElLabelsBox);	

				//Title:		
				var innerHTML = "<hr style='color:rgb(250,209,99)'/><div style='text-align:center'><strong>GTD Label Assistant</strong><br/>(Click to Automatically Add a Label)</div>";
				
				//GTD Setup:
				innerHTML += "<DIV id='GTDGmail_LabelBoxSetup' class='GTDLabelsAdminBox_Setup'></DIV>";
				ElLabelsBox.innerHTML = innerHTML;
				
				//GTD Guide:
				var ElLabelsBox_Guide = document.createElement("DIV");
				ElLabelsBox_Guide.innerHTML = "<a id='GTD_ShowHideLink_LabelsBox_Guide' href='' onclick=\"GTDGmail_Common.clickHandler_ShowHide(this, false);GTDGmail_Common.loadIframe('GTDLabelBox_Guide', 'http://www.gtdgmail.com/directaccess/labels/');return false;\" next='show' elToShowHide='GTDLabelBox_Guide' textShow='Show GTD Guide&#187;' textHide='Hide GTD Guide' class='GTDLabelBox_NewBox_ShowHide' >Show GTD Guide&#187;</a><br/>";				
				ElLabelsBox_Guide.innerHTML += "<iframe id='GTDLabelBox_Guide' style='display:none;height:300px;width:100%;' src=''></iframe>";
				// Attach GTD Guide:
				ElLabelsBox.appendChild( ElLabelsBox_Guide );
				
				// Add the Setup box for rapid establishing of labels:
				this.createBox_Setup();
			}
			
			
			
			
			// =============
			// Now Add the Prefix Box
			if( !document.getElementById("GTDLabelsAdmin_Select") ){
				var ElInputBox = document.getElementById("plt");
				if( ElInputBox ){
					var ElSelect = document.createElement("SELECT");
					ElSelect.id = "GTDLabelsAdmin_Select";
					ElSelect.setAttribute("onchange", "GTDGmail_LabelsAdmin.clickHandler_DropDownChange();");
					ElInputBox.parentNode.insertBefore(ElSelect, ElInputBox);
					
					ElSelect.innerHTML += "<option value=''>No Prefix</option>";
					var Types = ["Context", "Status", "Project", "Reference"];
					for( var i = 0; i < Types.length; i++ ){
						var typeStr = Types[i];
						ElSelect.innerHTML += this.getHtml_CreateLabelPrefixOption(GTDGmail_Common.SharedObj.LabelTypesObj[typeStr].displayName, GTDGmail_Common.SharedObj.LabelTypesObj[typeStr].prefix);
					}
					
					// Hook up the Create button to do the prefix thing
					var ElButton = document.getElementById("plb");
					ElButton.setAttribute("onclick", "GTDGmail_LabelsAdmin.clickHandler_ApplyPrefix()");
				}
			}
			
			// Make sure links are responsive:
			this.addRefreshHooks();
		
		}catch(e){
			//alert(e.toString());
		}
		
		/*
		// Set up a call back (good to catch things like Remove)
		if( GTDGmail_LabelsAdmin.pageHasLabelsAdmin() && bool_keepRefreshing==true ){
			setTimeout("GTDGmail_LabelsAdmin.handleLabelsAdmin(true)", 8000);
		}
		*/
	},
	getHtml_CreateLabelPrefixOption: function(type, prefix){
		// Look up Options, to get last chosen prefix
		var lastPrefix = GTDGmail_Common.SharedObj.Options.getOption("char", "GTDGmail_LabelAdmin_LastPrefix", "");
		
		var selectedStr = "";
		if( lastPrefix!="" && lastPrefix==prefix ){
			// Change selected based on settings:
			//selectedStr = "selected";		DO NOT RELOAD
			//document.getElementById("GTDLabelsAdmin_Select").style.color = "color:rgb(0,102,51)";
		}
		return "<option value='" + prefix + "' " + selectedStr + " style='color:rgb(0,102,51);'>Prefix " + type + ": (" + prefix + ")</option>";
	},
	
	addRefreshHooks: function(){
		/*
			Update existing elements to have an onclick, that causes a refresh (NavBar & Labels)
			The refresh is on a timeout
			Targets for onclick:
				Rename/Remove
		*/
		
		var onclickStr = "GTDGmail_LabelsAdmin.initRefresh();GTDGmail_LabelsAdmin.broadcastLabelChange();";
		
		/* Inbox...
			Retrieve element with the ID 'nds'
				Establish a Treewalker over it
				For any item with an ID starting 'ds_', apply the onclick command
		*/
		var ElStart = document.getElementById("l");
		ElStart = ElStart.firstChild;
		var tw = document.createTreeWalker(ElStart, NodeFilter.SHOW_ELEMENT, null, false);
		for(var childNode = tw.firstChild(); childNode!=null; childNode = tw.nextNode()){
			if( childNode.id && childNode.id.indexOf("c_")!=-1 ){
				var oldOnclick = childNode.getAttribute("onclick");
				if( !oldOnclick || oldOnclick==null || oldOnclick=="" ){
					oldOnclick = "";
				}
				if( oldOnclick.indexOf( onclickStr )==-1 ){
					childNode.setAttribute("onclick", onclickStr + oldOnclick);
				}
			}
		}
	},
	initRefresh: function(){
		setTimeout("GTDGmail_LabelsAdmin.handleLabelsAdmin(0, false);", 500);
		setTimeout("GTDGmail_LabelsAdmin.handleLabelsAdmin(0, false);", 1000);
		setTimeout("GTDGmail_LabelsAdmin.handleLabelsAdmin(0, false);", 3000);
	},
	
	createBox_Setup: function(){
		/*
			Do test on the main Labels (T: To Do, R: Reference)
			Do a test on the Statuses
		*/
		
		// Retrieve Container (as defined in the handle... funciton):
		var ElBoxSetup = document.getElementById("GTDGmail_LabelBoxSetup");
		// Clear it out:
		ElBoxSetup.innerHTML = "";
		
		var innerHTML = "";
		var foundOne = false;
		innerHTML += "<a id='GTDGmail_LabelsToAdd_ShowHide' href='' onclick=\"GTDGmail_Common.clickHandler_ShowHide(this, false);return false;\" next='hide' elToShowHide='GTDGmail_LabelsToAdd' textShow='Show Labels to Add&#187;' textHide='Hide Labels to Add' class='' >Hide Labels to Add</a>";
		innerHTML += "<table id='GTDGmail_LabelsToAdd' width='100%'><tr>";
		innerHTML += "<td class='GTDLabelsAdminBox_Setup' width='33%' valign='top'>";
			// The Statuses:
			for( var i = 0; i < GTDGmail_Common.SharedObj.StandardLabels.Status.StatusArray.length; i++ ){
				var labelId = GTDGmail_Common.SharedObj.StandardLabels.Status.StatusArray[i];
				if( !GTDGmail_Common.testLabelInUse("Status", GTDGmail_Common.SharedObj.StandardLabels.Status[labelId] ) ){
					innerHTML += this.createBox_Setup_CreateAddLabelLink( GTDGmail_Common.SharedObj.StandardLabels.Status[labelId] ); 
					foundOne = true;
				}
			}
		innerHTML += "</td><td class='GTDLabelsAdminBox_Setup' width='33%' valign='top'>";
			// The Contexts:
			for( var i = 0; i < GTDGmail_Common.SharedObj.StandardLabels.Context.ContextArray.length; i++ ){
				var labelId = GTDGmail_Common.SharedObj.StandardLabels.Context.ContextArray[i];
				if( !GTDGmail_Common.testLabelInUse("Context", GTDGmail_Common.SharedObj.StandardLabels.Context[labelId] ) ){
					innerHTML += this.createBox_Setup_CreateAddLabelLink( GTDGmail_Common.SharedObj.StandardLabels.Context[labelId] ); 
					foundOne = true;
				}
			}
		innerHTML += "</td><td class='GTDLabelsAdminBox_Setup' width='33%' valign='top'>";
			// The Rest:
			if( !GTDGmail_Common.testLabelInUse("Reference", GTDGmail_Common.SharedObj.StandardLabels.Reference.Reference) ){
				innerHTML += this.createBox_Setup_CreateAddLabelLink( GTDGmail_Common.SharedObj.StandardLabels.Reference.Reference ); 
				foundOne = true;
			}
			if( !GTDGmail_Common.testLabelInUse("Reference", GTDGmail_Common.SharedObj.StandardLabels.Reference.ProjectHome) ){
				innerHTML += this.createBox_Setup_CreateAddLabelLink( GTDGmail_Common.SharedObj.StandardLabels.Reference.ProjectHome ); 
				foundOne = true;
			}
		innerHTML += "</td></tr></table><br/>";
		
		if( foundOne==true ){
			ElBoxSetup.innerHTML = innerHTML;
		}
		
		

	},
	createBox_Setup_CreateAddLabelLink: function(labelStr){
		var innerHTML = "";
		innerHTML += "<li><a href='' onclick=\"GTDGmail_LabelsAdmin.clickHandler_AddLabel('";
		innerHTML += labelStr;
		innerHTML += "');return false;\" class=''>Add Label '";
		innerHTML += labelStr;
		innerHTML += "'</a></li>";
		
		return innerHTML;
	},
	
	
	
	clickHandler_ApplyPrefix: function(){
		/*
			Retrieve the prefix from the drop down menu
			Insert it into the textbox
		*/
		try{
			var ElLabels_TextBox = document.getElementById("plt");
			
			// Retrieve the selected option:
			var ElSelect = document.getElementById("GTDLabelsAdmin_Select");

			// Loop over children
			var optionCount = 0;
			for( var i = 0; i < ElSelect.childNodes.length; i++ ){
				if( ElSelect.childNodes[i].nodeName.toLowerCase()=="option" ){
					if( ElSelect.selectedIndex==optionCount ){
						// We have the selected option
						
						// Remember it:
						GTDGmail_Common.SharedObj.Options.setOption("char", "GTDGmail_LabelAdmin_LastPrefix", ElSelect.childNodes[i].value);
						
						// Add it's value to the start of the text box:
						ElLabels_TextBox.value = ElSelect.childNodes[i].value + ElLabels_TextBox.value;					
					}
					optionCount++;
				}
			}
			
			
			
			// Make Sure We Call Back to Get the Page Rendered Correctly:
			this.broadcastLabelChange();
		}catch(e){
			//alert(e.toString());
		}
		
	},
	
	clickHandler_AddLabel: function(labelStr){
		/*
			Put a new label name in the text box
			Activate a button click
		*/
		try{
			var ElLabels_TextBox = document.getElementById("plt");
			var ElLabels_SearchButton = document.getElementById("plb");
			ElLabels_SearchButton.disabled = false;
			
			ElLabels_TextBox.value = labelStr;
			
			GTDGmail_Common.doClickEvent(ElLabels_SearchButton);
			
			// Make Sure We Call Back to Get the Page Rendered Correctly:
			this.broadcastLabelChange();
		}catch(e){
			//alert(e.toString());
		}
	},

	clickHandler_DropDownChange: function(){
		/*
			Change the color of the text, depending on whether it is No Prefix or a Prefix
		*/
		
		try{
			
			// Retrieve the selected option:
			var ElSelect = document.getElementById("GTDLabelsAdmin_Select");

			// Loop over children
			var optionCount = 0;
			for( var i = 0; i < ElSelect.childNodes.length; i++ ){
				if( ElSelect.childNodes[i].nodeName.toLowerCase()=="option" ){
					if( ElSelect.selectedIndex==optionCount ){
						// We have the selected option
						
						if( ElSelect.childNodes[i].value=="" ){
							ElSelect.style.color = "black";
						}else{
							ElSelect.style.color = "rgb(0,102,51)";
						}
					}
					optionCount++;
				}
			}
		}catch(e){
			//alert(e.toString());
		}
	},
	
	broadcastLabelChange: function(){
		// Notify other things that the label has changed
		
		GTDGmail_NavBar.closedLabelsBoxCount = 0;
		
		setTimeout("GTDGmail_NavBar.handleLabels(20, false);GTDGmail_LabelsAdmin.handleLabelsAdmin(false);GTDGmail_SearchBar.handleSearchBar(true);", 1000);
		setTimeout("GTDGmail_NavBar.handleLabels(20, false);GTDGmail_LabelsAdmin.handleLabelsAdmin(false);GTDGmail_SearchBar.handleSearchBar(true);", 2000);
	},
}