
GTDGmail_PrintEmails = {
	
	hasEmails: function(){
		/*
			Test to see if we have an inbox of some sort
		*/
		
		return GTDGmail_Popup_Label.pageHasInbox();
	},
	
	handleEmails: function(){
		/*
			Inject a "Print Inbox as Hipster PDA Cards" link
		*/
		try{
			if( !document.getElementById("CmdGtdPrint") ){
				var ElHookPoint = null;
				try{
					ElHookPoint = document.getElementById("tcb");
					var ElTmp = null;
					for( var i = 0; i < ElHookPoint.childNodes.length; i++ ){
						if( ElHookPoint.childNodes[i].nodeName.toLowerCase()=="div" ){
							if( ElHookPoint.childNodes[i].className.toLowerCase()=="tbc" ){
								// Found it
								ElTmp = ElHookPoint.childNodes[i];
							}
						}
					}
					if( ElTmp ){
						ElHookPoint = ElTmp.lastChild;
					}else{
						ElHookPoint = null;
					}
				}catch(e){
					ElHookPoint = null;
				}
				
				if( ElHookPoint ){
					ElHookPoint.innerHTML = "<div style='float:left;'>" + ElHookPoint.innerHTML + "</div><div style='text-align:right;'><input type='submit' id='CmdGtdPrint' style='height:19px;font-size:8pt;' value='Print Hipster PDA Cards [GTD]' onclick='GTDGmail_PrintEmails.clickHandler_DoPrint();' title='Open a new window with your GTD emails formatted into printable cards.' /></div>";		
				}else{
					// Insert it elsewhere
					var ElTopNavContainer = document.getElementById("TopNavContainer");
					if( ElTopNavContainer ){
						ElTopNavContainer.innerHTML += "<input type='submit' id='CmdGtdPrint' style='height:19px;font-size:8pt;margin-top:2px;' value='Print Hipster PDA Cards [GTD]' onclick='GTDGmail_PrintEmails.clickHandler_DoPrint();' title='Open a new window with your GTD emails formatted into printable cards.' />";
					}
				}
				
				
			}
		}catch(e){
			//alert(e.toString());
		}
	},
	
	clickHandler_DoPrint: function(){
		/*
			Explicitly clear out existing InboxData object from shared memory
			Create a new object, and read the emails
			Open up a new window
		*/
		try{
			GTDGmail_Common.SharedObj.InboxData = null;
			GTDGmail_Common.SharedObj.InboxData = new GTDGmail_InboxData();
			
			// Process the emails:
			var ElFirstItem = document.getElementById("w_0");
			var ElInbox = ElFirstItem.parentNode;
			
			var useStarNextAction = GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.Status.UseStarForNextAction", false);
			
			var LabelsArray = null;
			var subjectStr = "";
			var emailIntroStr = "";
			var hasStar = false;
			
			for( var i = 0; i < ElInbox.childNodes.length; i++ ){
				var ElRow = ElInbox.childNodes[i];
				if( ElRow.id.indexOf("w_")!=-1 ){
					// It's a good row
					
					
					// Get labels:
					if( ElRow.childNodes[4].firstChild ){
						// Get Subject:
						var subjectStr = ElRow.childNodes[4].innerHTML;
						
						emailIntroStr = subjectStr.replace(/^([^$]+)\<span class\=\"p\"\> -/, "");
						emailIntroStr = emailIntroStr.replace(/\<([^>]+)\>/g, "");
						subjectStr = subjectStr.replace(/\<span class\=\"p\"\> -([^$]+)$/, "");
						subjectStr = subjectStr.replace(/\<([^>]+)\>/g, "");
						
						if( ElRow.childNodes[4].firstChild.className=="ct" ){
							// It has labels
							var labelsStr = ElRow.childNodes[4].firstChild.innerHTML;
													
							// Strip them from subject:
							subjectStr = subjectStr.replace(labelsStr, "");
							
							LabelsArray = labelsStr.split(", ");
						}else{
							LabelsArray = new Array();
						}
					}else{
						LabelsArray = new Array();
						subjectStr = "";
					}
					
					// Get is stared
					if( ElRow.childNodes[1].style.backgroundImage.indexOf("star_on")>-1 || ElRow.childNodes[1].className.indexOf("sc t")>-1 ){
						hasStar = true;
					}else{
						hasStar = false;
					}
					
					// Get date
					dateStr = ElRow.childNodes[6].innerHTML.replace(/\<([^>]+)\>/g, "");
					
					
					// Bit of a cheat, but if Star (instead of Next Action), pump Next Action label into labels array
					if(useStarNextAction && hasStar){
						LabelsArray[LabelsArray.length] = GTDGmail_Common.SharedObj.StandardLabels.Status.NextAction;
					}
					
					if( (LabelsArray.length > 0) ){
						// Only those with labels
						if( !GTDGmail_Common.arrayContains( LabelsArray, GTDGmail_Common.SharedObj.StandardLabels.Status.Finished ) ){
							// Only those not finished
							GTDGmail_Common.SharedObj.InboxData.addEmail( LabelsArray, subjectStr, emailIntroStr, dateStr, hasStar );
						}
					}
				}
			}
			
			
			// Now fire a new window:
			
			
			//alert( document.GtdOverlayGlobals.browser_appcontent.GtdShared.tst );
			document.GtdOverlayGlobals.browser_appcontent.GtdShared.ChromeOnlyExec.openTab("chrome://gtdgmail/content/print_hipster_pda_frame.htm");
			
			
			
			//GTDGmail_Common.SharedObj.ChromeOnlyExec = new ChromeOnlyExecution();		
			//GTDGmail_Common.SharedObj.ChromeOnlyExec.openWindow("chrome://gtdgmail/content/print_hipster_pda.htm");
			
			
			
			
			//alert( GTDGmail_Common.SharedObj.InboxData.getStatusesByContext("C:Car", "P:Bumble Search").FoundStatusesArray.toString() );
			
		}catch(e){
			//alert(e.toString());
		}
		
	},

}

