
var GTDGmail_SearchBar = {
	pageHasFreshSearchBar: function(){
		var elSearchForm = document.evaluate("//FORM[@id='s']", document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null).singleNodeValue;
		
		if( elSearchForm ){
			return true;
		}else{
			return false;
		}
	},
	
	handleSearchBar: function(doRefresh){
		/*
			Load the search bar elements (text box and button) into the Shared Object
			
			Load a new Search box
			Create a container DIV
				Load it with a input box
				For each Type:
						Load check boxes for each label in that type
						Add it
				Manually create a More Search Options
		*/
		
		try{
			
			// =============================================
			// LOAD SEARCH ELEMENTS INTO SHARED MEMORY:
			var elSearchForm = document.evaluate("//FORM[@id='s']", document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null).singleNodeValue;
			
			// Process the children (which should be INPUTS)
			for( var i = 0; i < elSearchForm.childNodes.length; i++ ){
				var elInput = elSearchForm.childNodes[i];
				if( elInput.nodeName.toLowerCase()=="input" ){
					if( elInput.name.toLowerCase()=="q" ){
						// It's the text box
						GTDGmail_Common.SharedObj.Search.ElTextBox = elInput;
					}
					if( elInput.getAttribute("type")=="submit" ){
						// It's a button
						if( !elInput.getAttribute("onclick") || elInput.getAttribute("onclick")=="" ){
							// Search Mail button
							GTDGmail_Common.SharedObj.Search.ElButton = elInput;
						}
					}
				}
			}
					
			// CREATE SEARCH BOX
			if( GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.GTDSearch", false) ){
				if( doRefresh ){
					var ElBox = document.getElementById("GTDSearchBox");
					ElBox.parentNode.removeChild(ElBox);
					ElBox = null;
					
					var ElLink = document.getElementById("GTDSearch_ShowHide");
					ElLink.parentNode.removeChild(ElLink);
					ElLink = null;
				}
				if( !document.getElementById("GTDSearchBox") ){
				
					// Create ShowHide Link
					var ElDivShowHide = document.createElement("DIV");
					ElDivShowHide.id = "GTDSearch_ShowHide";
					ElDivShowHide.innerHTML = "<a id='GTDSearch_ShowHide_Link' href='' style='color:rgb(0,102,51);font-size:0.7em;' onclick=\"GTDGmail_Common.clickHandler_ShowHide(this, false);GTDGmail_SearchBar.showHide_HandleAds(this);return false;\" next='show' elToShowHide='GTDSearchBox' textShow='Show GTD Search' textHide='Hide GTD Search' class='' >Show GTD Search</a>";
					
					
					// Create and Hook:
					var ElDiv = document.createElement("DIV");
					ElDiv.id = "GTDSearchBox";
					ElDiv.className = "GTDSearchBox";
					ElDiv.style.display = "none";
					
					var ElHookPoint = document.getElementById("nt1");
					
					//ElHookPoint = ElHookPoint.parentNode;
					//ElHookPoint.appendChild(ElDivShowHide);
					//ElHookPoint.appendChild(ElDiv);
					ElHookPoint.parentNode.insertBefore(ElDivShowHide, ElHookPoint);
					ElHookPoint.parentNode.insertBefore(ElDiv, ElHookPoint);
					
					// Create outline table:
					var innerHTML = "<table cellspacing='0' cellpadding='0' width='100%' ><tr><td valign='top' class='GTDSearchBox_SearchForm'>";
					innerHTML += "<strong>GTD Search:</strong><br/><input id='gtdgmail_GTDSearchBox_Input' searchStr=' ' type='text' style='width:200px' />";
					innerHTML += "<div id='GTDSearchBox_Options'><table><tr id='GTDSearch_Options_Labels'></tr></table></div>";
					innerHTML += "</td></tr><tr><td colspan='2' class='GTDSearchBox_SearchExecute'>";
					innerHTML += "<div align='right'><input type=submit value='Search Mail with GTD' onclick='GTDGmail_SearchBar.clickHandler_ConductSearch();'><br/><a href=''  onclick='GTDGmail_SearchBar.clickHandler_ResetSearch();return false;'>Reset Search</a></div>";
					innerHTML += "</td></tr></table>";
					
					innerHTML = "<table id='GTDSearch_MainTable' cellspacing='0' cellpadding='0' width='100%' ><tr><td valign='top' class='GTDSearchBox_SavedSearch' width='30%'><div id='GTDSearchBox_SavedSearch' style='padding:3px;'></div></td><td valign='top' width='70%'>" + innerHTML + "</td></tr></table>";
					
					ElDiv.innerHTML = innerHTML;
					
					// Retrieve TR for Adding Label-Types, and their Labels (as TDs)
					var ElTR_LabelCheckboxes = document.getElementById("GTDSearch_Options_Labels");
					var innerHTML = "";
					var Types = ["Context", "Status", "Project", "Reference", "Misc"];
					
					for( var i = 0; i < Types.length; i++ ){
						innerHTML += this.getHtml_SearchBox_LabelCheckboxes(Types[i]);
					}
					ElTR_LabelCheckboxes.innerHTML = innerHTML;
					
					// Add Advanced Search stuff
					var ElSearchOptions = document.getElementById("GTDSearchBox_Options");
					var innerHTML = "";
					innerHTML += "<a id='GTDSearch_ShowHide_Advanced' href='' onclick=\"GTDGmail_Common.clickHandler_ShowHide(this, false);return false;\" next='hide' elToShowHide='GTDSearchBox_Options_Advanced' textShow='Show Advanced Options&#187;' textHide='Hide Advanced Options' class='' >Hide Advanced Options</a>";
					innerHTML += "<table id='GTDSearchBox_Options_Advanced' style=''><tr>";
					innerHTML += "<td>";
						// Time
						innerHTML += "<strong>Time</strong>";
						innerHTML += "<table ><tr><td>After:</td><td><input type='text' searchStr='after:' id='gtdgmail_after'/>";
							innerHTML += "&nbsp;[1 ";
							innerHTML += this.getHtml_DateLink("gtdgmail_after", "day") + "/";
							innerHTML += this.getHtml_DateLink("gtdgmail_after", "week") + "/";
							innerHTML += this.getHtml_DateLink("gtdgmail_after", "month") + "/";
							innerHTML += this.getHtml_DateLink("gtdgmail_after", "year");
							innerHTML += " ago]";
						innerHTML += "</td></tr>";
						innerHTML += "<tr><td>Before:</td><td><input type='text' searchStr='before:' id='gtdgmail_before'/>";
							innerHTML += "&nbsp;[1 ";
							innerHTML += this.getHtml_DateLink("gtdgmail_before", "day") + "/";
							innerHTML += this.getHtml_DateLink("gtdgmail_before", "week") + "/";
							innerHTML += this.getHtml_DateLink("gtdgmail_before", "month") + "/";
							innerHTML += this.getHtml_DateLink("gtdgmail_before", "year");
							innerHTML += " ago]";
						innerHTML += "</td></tr></table>";
					innerHTML += "</td><td>";
						// Misc. Labels (e.g. Starred)
						innerHTML += "<strong>Other Refinements</strong><br/>";
						innerHTML += "<input id='gtdgmail_is_starred' type='checkbox' >Is Starred<br/>";
						innerHTML += "<input id='gtdgmail_has_attachment' type='checkbox' >Has Attachment<br/>";
					innerHTML += "</td></tr></table>";
						
					ElSearchOptions.innerHTML += innerHTML;
					
					// Load the Saved Search form:
					this.createSavedSearchesBox();
					
					// Finally, load the last search
					var saveStr = GTDGmail_Common.SharedObj.Options.getOption("char", "GTDGmail_SearchBox_LastSearch", "");
					this.loadFormState(saveStr);
					// See if anything to show:
					GTDGmail_Common.hideShowHideElements();
				}	
			}

			this.injectComboSavedSearches();

		}catch(e){
			//alert(e.toString());
		}
	},
	getHtml_SearchBox_LabelCheckboxes: function(labelType){
		/*
			For this label type, print the heading of labelType's display name
				Then, for each label in this type, add a checkbox
				The checkbox must have the associated part of the search string, under attribute 'searchString'
		*/
		
				
		var innerHTML = "<strong>" + GTDGmail_Common.SharedObj.LabelTypesObj[labelType].displayName + "</strong><br/>";
		var foundOne = false;
		for( var j = 0; j < GTDGmail_Common.SharedObj.LabelsObj[labelType].LabelArray.length; j++ ){
			var labelStr = GTDGmail_Common.SharedObj.LabelsObj[labelType].LabelArray[j];
			innerHTML += "<input id=\"gtdgmail_label_" + labelStr.replace(/[ &]/g, "-") + "\" type='checkbox' >" + labelStr + "<br/>";
			foundOne = true;
		}
		
		if( foundOne ){
			if( labelType=="Misc" ){
				return "<td valign='top'><div class='GTDMisc'>" + innerHTML + "</div></td>";
			}else{
				return "<td valign='top'>" + innerHTML + "</td>";
			}
		}else{
			return "";
		}
	},
	getHtml_DateLink: function(textBoxId, timeUnit){
		/*
			timeUnit: day, week, month, year
			Create a link that sets the date textbox with the current date - timeUnit
		*/
		
		// Get text box:
		//var ElTextBox = document.getElementById(textBoxId);
		//if(!ElTextBox) return "";
		
		try{
			var htmlLink = "<a id='" + textBoxId + "_" + timeUnit + "' href='' style='color:black;' onclick=\"document.getElementById('" + textBoxId + "').value='<!DATEVALUE!>';return false\">" + timeUnit + "</a>";
			
			// Calculate the time:
			var TimeNow = new Date();
			
			var TimeThen = null;
			if( timeUnit=="day"){
				TimeThen = new Date(TimeNow.getTime() - (1 * 86400000));
			}
			if( timeUnit=="week"){
				TimeThen = new Date(TimeNow.getTime() - (7 * 86400000));
			}
			if( timeUnit=="month"){
				TimeThen = new Date(TimeNow.getTime() - (30 * 86400000));
			}
			if( timeUnit=="year"){
				TimeThen = new Date(TimeNow.getTime() - (365 * 86400000));
			}

			// return value
			var dateStr = GTDGmail_Common.getFormattedDate(TimeThen);
			
			return htmlLink.replace("<!DATEVALUE!>", dateStr);
		}catch(e){
			//alert(e.toString());
		}
		
	},

	showHide_HandleAds: function(ElShowHideLinks){
		/*
			Get next attribute
			If show:
				show ads
			If hide:
				hide ads
		*/

		var ElAdBox = document.getElementById("rh");
		if( !ElAdBox ){
			return;
		}

		if( ElShowHideLinks.getAttribute("next")=="show" ){
			// Show the ads
			ElAdBox.style.display = "";
		}
		if( ElShowHideLinks.getAttribute("next")=="hide" ){
			// Hide the ads
			ElAdBox.style.display = "none";
		}
	},

	injectComboSavedSearches: function(){
		// CREATE COMBO FOR SAVED SEARCHES
		try{
		if( GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.GTDSearchCombo", false) ){
			var ElComboSavedSearch = document.getElementById("ComboSavedSearch");
			if( !ElComboSavedSearch ){
				// Add it
				var ElDivShowHide = document.getElementById("GTDSearch_ShowHide");
				ElDivShowHide.innerHTML += "<select id='ComboSavedSearch' style='display:none;margin-left:5px;font-size:0.65em;height:19px;width:109px;' title='Quickly Conduct a Saved Search'></select>";
				
				ElComboSavedSearch = document.getElementById("ComboSavedSearch");
			}
			ElComboSavedSearch.innerHTML = "";

			// Read in Existing Saved Searches:
			var splitItem = "<%*>";
			var splitSaved = "<\^%/>";
			
			var SavedSearchesArray = GTDGmail_Common.SharedObj.Options.getOption("char", "GTDGmail_SearchBox_SavedSearches", "").split(splitSaved);

			var foundOne = false;
			var innerHTML = "<option value='' style='color:#666666;'>Saved Searches...</option>";
			for( var i = 0; i < SavedSearchesArray.length; i++ ){
				var SearchArray = SavedSearchesArray[i].split(splitItem);
				if( SearchArray[0]!="" && SearchArray[1]!="" ){
					innerHTML += "<option onclick=\"GTDGmail_SearchBar.clickHandler_LoadSavedSearch(this);return false;\" item=\"" + SearchArray[0] + "\">";
					innerHTML += SearchArray[0];
					innerHTML += "</option>";
					foundOne = true;
				}
			}
			ElComboSavedSearch.innerHTML = innerHTML;

			if( foundOne ){
				// Show it
				ElComboSavedSearch.style.display = "";
			}else{
				// Hide it
				ElComboSavedSearch.style.display = "none";
			}			
		}
		}catch(e){
			//alert(e.toString());
		}
	},
	
	/*
	loadSavedSearch: function(saveStr){

		
		var splitItem = "<!~>";
		var splitNode = "<@?*>";
		
		// Clear out the search box
		this.clickHandler_ResetSearch(true);
		
		// Break the save string up, format: <type>(splitItem)<id>(splitItem)<value?>(splitNode)
		var NodesArray = saveStr.split( splitNode );
		for( var i = 0; i < NodesArray.length; i++ ){
			var BreakdownArray = NodesArray[i].split( splitItem );
			if( BreakdownArray.length >= 2 ){
				var Node = document.getElementById( BreakdownArray[1] );
				if( Node ){
					switch( BreakdownArray[0].toLowerCase() ){
						case "text":
							Node.value = BreakdownArray[2];
						break;
						case "checkbox":
							Node.checked = true;
						break;
					}
				}
			}
		}
	},
	*/
	
	clickHandler_ResetSearch: function(bool_DoNotAlterLastSearch){
		/*
			Cause it to be reloaded
		*/
		
		try{
			// Clear last search:
			if(! bool_DoNotAlterLastSearch ){
				GTDGmail_Common.SharedObj.Options.setOption("char", "GTDGmail_SearchBox_LastSearch", "")
			}
			
			this.searchBox_TreeWalker( this.twCallBack_resetSearch );
		}catch(e){
			//alert(e.toString());
		}
	},
	
	clickHandler_ConductSearch: function(){		
		try{
		
			// Execute Search:
			var searchStr = this.searchBox_TreeWalker( this.twCallBack_BuildSearchStr );
			
			
			searchStr = searchStr.replace(/( ){1,}/g, " ");
			searchStr = searchStr.replace(/(^( ){1,}|( ){1,}$)/g, "");
			
			
			
			this.doSearch( searchStr );
		}catch(e){
			//alert(e.toString());
		}
	},
	
	searchBox_TreeWalker: function(CallFunction){
		var returnStr = "";
		
		var ElDiv = document.getElementById('GTDSearchBox');
			
		var tw = document.createTreeWalker(ElDiv, NodeFilter.SHOW_ELEMENT, null, false);
		for(var childNode = tw.firstChild(); childNode!=null; childNode = tw.nextNode()){
			// If node has type:
			if( childNode.id.indexOf("gtdgmail_")>-1 && childNode.getAttribute("type") ){
				returnStr += CallFunction( childNode );
			}
		}
		
		return returnStr;
	},
	twCallBack_BuildSearchStr: function(childNode){
		/*
			Extract the type
			The ID tells it how it is,
				gtdgmail_<type>_<value> => <type>:<value>
				e.g. gtdgmail_label_!-Next-Action => label:!-Next-Action
		*/
		try{
			if( childNode.id=="gtdgmail_GTDSearchBox_Input" ){
				return childNode.value + " ";
			}
		
			var SplitIdArray = childNode.id.split("_");
			var ValueArray = SplitIdArray.slice(2);
			
						
			switch( childNode.getAttribute("type").toLowerCase() ){
				case "text":		
					if( childNode.value!="" ){
						return SplitIdArray[1] + ":" + childNode.value + " ";
					}else{
						return "";
					}
				break;
				case "checkbox":
					if( childNode.checked ){
						return SplitIdArray[1] + ":" + ValueArray.join("_") + " ";
					}else{
						return "";
					}
				break;
			}
			
			return "";
		}catch(e){
			//alert(e.toString());
		}
	},
	/*
	twCallBack_BuildSaveSearch: function(childNode){
		//Extract the type
		
		
		var splitItem = "<!~>";
		var splitNode = "<@?*>";
		
		switch( childNode.getAttribute("type").toLowerCase() ){
			case "text":
				if( childNode.value!="" ){
					return "text" + splitItem + childNode.id + splitItem + childNode.value + splitNode;
				}else{
					return "";
				}
			break;
			case "checkbox":
				if( childNode.checked ){
					return "checkbox" + splitItem + childNode.id + splitNode;
				}else{
					return "";
				}
			break;
		}
		
		return "";
	},
	*/
	twCallBack_resetSearch: function(childNode){
		/*
			Extract the type
		*/
			
		switch( childNode.getAttribute("type").toLowerCase() ){
			case "text":
				childNode.value = "";
			break;
			case "checkbox":
				childNode.checked = false;
			break;
		}
		
	},
	
	
	


	
	
	
	
	/*
		===========
		SAVED SEARCHES
	*/
	
	createSavedSearchesBox: function(){
		/*
			Load the options, and create a list of saved searches
			Plus add the ability to Add a new Saved Search
		*/
		
		var ElSavedSearches = document.getElementById("GTDSearchBox_SavedSearch");
		ElSavedSearches.innerHTML = "";

		
		var innerHTML = "<strong>Saved Searches</strong<br/>";
		
		innerHTML += "<ul>";	
		
		
		var splitItem = "<%*>";
		var splitSaved = "<\^%/>";
		
		// Read in Existing Saved Searches:
		var SavedSearchesArray = GTDGmail_Common.SharedObj.Options.getOption("char", "GTDGmail_SearchBox_SavedSearches", "").split(splitSaved);
		for( var i = 0; i < SavedSearchesArray.length; i++ ){
			var SearchArray = SavedSearchesArray[i].split(splitItem);
			if( SearchArray[0]!="" && SearchArray[1]!="" ){
				innerHTML += "<li><a href='' title='Click to load this Saved Search' onclick=\"GTDGmail_SearchBar.clickHandler_LoadSavedSearch(this);return false;\" item=\"" + SearchArray[0] + "\">";
				innerHTML += SearchArray[0];
				innerHTML += "</a>";
				innerHTML += "&nbsp;[<a href='' title='Remove this Saved Search' style='color:rgb(204,28,15);font-family:verdana;' onclick=\"GTDGmail_SearchBar.clickHandler_RemoveSavedSearch(this);return false;\" item=\"" + SearchArray[0] + "\">X</a>]";
				innerHTML += "</li>";
			}
		}
		innerHTML += "</ul>";
		
		// Put a show hide for Create New Search
		innerHTML += "<a id='GTD_SearchBox_SavedSearches_AddNew_ShowHide' href='' onclick=\"GTDGmail_Common.clickHandler_ShowHide(this, false);return false;\" next='show' elToShowHide='GTD_SearchBox_SavedSearches_AddNew' textShow=\"Create New Search&#187;\" textHide=\"Hide 'Create New Search'\" class='' >Create New Search&#187;</a></div>";
		
		ElSavedSearches.innerHTML = innerHTML;
		
		// Create New Search
		var ElSavedSearches_AddNew = document.createElement("div");
		ElSavedSearches_AddNew.id = "GTD_SearchBox_SavedSearches_AddNew";
		ElSavedSearches_AddNew.className = "GTDSearchBox_SavedSearch_AddNew";
		ElSavedSearches_AddNew.style.display = "none";
		
		var innerHTML = "";
		innerHTML += "<span style='font-size:0.9em;'>Build the search using the form, give it a name, and click 'Create New Saved Search'...</span><br/>";
		innerHTML += "<br/>Saved Search Name:<br/><input id='GTD_SearchBox_SavedSearches_AddNew_Name' type='text' style='width:100%' /><br/><br/>";
		innerHTML += "<input type='submit' onclick='GTDGmail_SearchBar.clickHandler_AddSavedSearch();return false;' value='Create New Saved Search' />";
		
		ElSavedSearches_AddNew.innerHTML = innerHTML;
		
		// Attach the Create New Search:
		ElSavedSearches.appendChild(ElSavedSearches_AddNew);

		this.injectComboSavedSearches();
	},
	
	clickHandler_LoadSavedSearch: function(ElLink){
		/*
			Stored in format:
				<name>(splitItem)<searchstr>(splitSaved)
			Process all Searches in Options until find the name we are after
				Load that search into the form

				Execute the search
					Pump the search into the Search box
				
		*/
		
		try{
			var savedSearchName = "";
			savedSearchName = ElLink.getAttribute("item");
		
			var splitItem = "<%*>";
			var splitSaved = "<\^%/>";
						
			var SavedSearchesArray = GTDGmail_Common.SharedObj.Options.getOption("char", "GTDGmail_SearchBox_SavedSearches", "").split(splitSaved);
			var searchStr = "";
			for( var i = 0; i < SavedSearchesArray.length; i++ ){
				var SearchArray = SavedSearchesArray[i].split(splitItem);
				if( SearchArray[0]==savedSearchName ){
					// Found it
					searchStr = SearchArray[1];
					break;
				}
			}
			if( searchStr=="" ){
				return;
			}
			
			// Load the form:
			this.loadFormState(searchStr);
			
			
			
			// Execute the search:
			this.doSearch( searchStr );
			
		}catch(e){
			//alert(e.toString());
		}
	},
	loadFormState: function(searchStr){
		/*
			Reset the form
			Drop any "
			Drop any word that begins with -
			Scan each remaining search term
				Try to find its ID, for instance, label:!-Next-Action => label_!-Next-Action
				If its found, mark the element, and drop the text from the search string
		*/
		try{					
			this.clickHandler_ResetSearch(true);
			if( searchStr=="" ) return;
			
			var miscSearchStr = searchStr;
			//var miscSearchStr = "";
			
			// HANDLE OR:
			var RegExpORinBrackets = new RegExp("(\(|^)([^()]+)OR([^()$]+)(\)|$)", "g");
			// Find all OR in brackets, and add them to the misc string
			var MatchArray = searchStr.match(RegExpORinBrackets);
			if( MatchArray ){
				for( var i = 0; i < MatchArray.length; i++ ){
					//miscSearchStr += " " + MatchArray[i];
				}
				// Remove OR in brackets
				searchStr = searchStr.replace(RegExpORinBrackets, "");
			}
						
			// HANDLE Negated Items:
			searchStr = " " + searchStr + " ";
			var RegExpNegated = new RegExp(" \-([^ ]+) ", "g");
			var MatchArray = searchStr.match(RegExpNegated);
			if( MatchArray ){
				for( var i = 0; i < MatchArray.length; i++ ){
					//miscSearchStr += " " + MatchArray[i];
				}
				// Remove negated items:
				searchStr = searchStr.replace(RegExpNegated, "");
			}
					
			// Now extract ':' items:
			searchStr = " " + searchStr + " ";
			var RegExpColonPhrases = new RegExp("([^ ]+)\:([^ ]+)", "g");
			var MatchArray = searchStr.match( RegExpColonPhrases );
			if( MatchArray ){
				var item = "";
				var SplitItemArray = [];
				var ValueArray = [];
				for( var i = 0; i < MatchArray.length; i++ ){
					item = MatchArray[i].replace(/\"/g, "");
					SplitItemArray = item.split(":");
					ValueArray = SplitItemArray.slice(1);
										
					var ElFormItem = null;
					if( SplitItemArray[0]=="before" || SplitItemArray[0]=="after" ){
						// Text box
						ElFormItem = document.getElementById("gtdgmail_" + SplitItemArray[0]);
					}else{
						// Checkbox
						ElFormItem = document.getElementById("gtdgmail_" + SplitItemArray[0] + "_" + ValueArray.join(":") );
					}
					
					if( ElFormItem ){
						// We have found it, activate it
						switch(SplitItemArray[0]){
							case "before":
							case "after":
								// Textbox
								ElFormItem.value = ValueArray.join(":");
								break;
							default:
								// Checkbox
								ElFormItem.checked = true;
								break;
						}
						
						// Remove this item from the misc string
						miscSearchStr = miscSearchStr.replace(MatchArray[i], "");
						
					}else{
						// Not found, retain this item
						//miscSearchStr += " " + MatchArray[i];
					}
				}
				// Remove all labels from the search string
				searchStr = searchStr.replace(RegExpColonPhrases, "");
			}
			
			
			// Add what remains of the search string to the miscSearch
			//miscSearchStr += " " + searchStr;
			
			miscSearchStr = miscSearchStr.replace(/( ){1,}/g, " ");
			miscSearchStr = miscSearchStr.replace(/(^( ){1,}|( ){1,}$)/g, "");
			
			var ElSearchBoxForm = document.getElementById("gtdgmail_GTDSearchBox_Input");
			ElSearchBoxForm.value = miscSearchStr;				
		}catch(e){
			//alert(e.toString());
		}
	},
	
	
	isSearchStrSaved: function(testSearchStr){
		try{
			var splitItem = "<%*>";
			var splitSaved = "<\^%/>";
		
			// Check not already in use
			var SavedSearchesArray = GTDGmail_Common.SharedObj.Options.getOption("char", "GTDGmail_SearchBox_SavedSearches", "").split(splitSaved);
			for( var i = 0; i < SavedSearchesArray.length; i++ ){
				var SearchArray = SavedSearchesArray[i].split(splitItem);
				if( SearchArray.length==2 ){
					if( SearchArray[0]!="" && SearchArray[1]!="" ){
						if( SearchArray[1]==testSearchStr ){
							return true;
						}
					}
				}
			}
		}catch(e){
			//alert(e.toString());
		}
			return false;
	},
	
	
	saveSearch: function(searchName, searchStr){
		// Write it to the options:
		
		
			var splitItem = "<%*>";
			var splitSaved = "<\^%/>";
			
			if( searchName=="" ){
				alert("Please enter a name for this search, for easy recall later.");
				return false;
			}
			
			if( searchName.indexOf("\"")>-1 ){
				alert("Please do not include the quote symbol (\") in the name.\n(Single quotes (\') are fine)");
				return false;
			}
			
			if( /^( ){1,}$/.test(searchName) ){
				alert("Please enter a name for this search, for easy recall later.");
				return false;
			}

			// Check not already in use (this name):
			var SavedSearchesArray = GTDGmail_Common.SharedObj.Options.getOption("char", "GTDGmail_SearchBox_SavedSearches", "").split(splitSaved);
			for( var i = 0; i < SavedSearchesArray.length; i++ ){
				var SearchArray = SavedSearchesArray[i].split(splitItem);
				if( SearchArray.length==2 ){
					if( SearchArray[0]!="" && SearchArray[1]!="" ){
						if( SearchArray[0]==searchName ){
							alert("This search name is already in use, please select another one and try again.");
							return false;
						}
					}
				}
			}
			
			// Append it to the options
			var oldOptionsStr = GTDGmail_Common.SharedObj.Options.getOption("char", "GTDGmail_SearchBox_SavedSearches", "");
			
			var newOptionsStr = oldOptionsStr + searchName + splitItem + searchStr + splitSaved;
			
			// Write it out:
			GTDGmail_Common.SharedObj.Options.setOption("char", "GTDGmail_SearchBox_SavedSearches", newOptionsStr);
			

			// Refresh the form:
			this.createSavedSearchesBox();
			
			return true;
	},
	
	clickHandler_AddSavedSearch: function(){
		/*
			Condense the form into a saveStr
			Add the new name + saveStr to the Options
		*/
		try{			
			var ElNameTextBox = document.getElementById('GTD_SearchBox_SavedSearches_AddNew_Name');
			if( !ElNameTextBox ){
				return false;
			}
			
			var savedSearchName = ElNameTextBox.value;
			
			var searchStr = this.searchBox_TreeWalker( this.twCallBack_BuildSearchStr );
			if( searchStr=="" ){
				alert("Please create a search using the GTD Search form to the left.");
				return false;
			}
			
			return this.saveSearch(savedSearchName, searchStr);
			
		}catch(e){
			//alert(e.toString());
		}
	},
	QuickAddSearch: function(){
		/*
			Prompt for a name
			Reset the form
			Set the text field equal to the current search
			Do normal add search
		*/

		try{
			var newNameStr = prompt("Please enter a name for this Saved Search:", "");
			if( newNameStr=="" ){
				alert("The search could not be saved.");
				return;
			}
			// Set the name
			var ElNameTextBox = document.getElementById('GTD_SearchBox_SavedSearches_AddNew_Name');
			ElNameTextBox.value = newNameStr;

			// Reset
			this.clickHandler_ResetSearch(true);

			// Set the field:
			var ElOurSearchTextBox = document.getElementById("gtdgmail_GTDSearchBox_Input");
			if( !ElOurSearchTextBox ){
				alert("The search could not be saved.");
				return;
			}
			
			if( this.saveSearch(newNameStr, GTDGmail_Common.SharedObj.Search.ElTextBox.value)==true ){
				alert("Search successfully saved.\nIt can be found under 'Show GTD Search'");
			}
		}catch(e){

		}
	},
	
	clickHandler_RemoveSavedSearch: function(ElRemoveLink){
		/*
			Load the options
			Scan along until 'savedSearchName' is found
			Remove it and the accompanying saveStr
		*/
		try{
			var savedSearchName = ElRemoveLink.getAttribute("item");

			var splitItem = "<%*>";
			var splitSaved = "<\^%/>";
			
			var newStr = "";
			
			var SavedSearchesArray = GTDGmail_Common.SharedObj.Options.getOption("char", "GTDGmail_SearchBox_SavedSearches", "").split(splitSaved);
			for( var i = 0; i < SavedSearchesArray.length; i++ ){
				var SearchArray = SavedSearchesArray[i].split(splitItem);
				if( SearchArray.length==2 ){
					if( SearchArray[0]!="" && SearchArray[1]!="" ){
						if( SearchArray[0]!=savedSearchName ){
							// Valid entry
							newStr += SavedSearchesArray[i] + splitSaved;
						}
					}
				}
			}
			
			// Write it out:
			GTDGmail_Common.SharedObj.Options.setOption("char", "GTDGmail_SearchBox_SavedSearches", newStr)
			
			
			// Refresh the form:
			this.createSavedSearchesBox();
		}catch(e){
			//alert(e.toString());
		}
	},
	
	
	
	
	
	
	
	doSearch: function(searchText){
		/*
			Use the Search box in SharedObj
			Set the value of the text box to searchText
			Initiate a click event
		*/
				
		searchText = searchText.replace(new RegExp(GTDGmail_Common.SharedObj.EncodeStrings.singleQuoteEncode, "g"), "\'");
		searchText = searchText.replace(new RegExp(GTDGmail_Common.SharedObj.EncodeStrings.quoteEncode, "g"), "\"");
		
		GTDGmail_Common.SharedObj.Search.ElTextBox.value = searchText;
		
		// Save this search:
		GTDGmail_Common.SharedObj.Options.setOption("char", "GTDGmail_SearchBox_LastSearch", searchText);
		
		GTDGmail_Common.doClickEvent( GTDGmail_Common.SharedObj.Search.ElButton );
		
	},
	
}
