/*

	Gtd Gmail
	(c) 2005 2006 Andy Mitchell [andy@gtdgmail.com]


	This code is covered by the GPL.

	My only additional terms are:

	If you utilise this code directly, please credit 'Andy Mitchell [andy@gtdgmail.com]'
	It is also a requirement to place the url, http://www.gtdgmail.com, somewhere within a public, easily accessible document (E.g. help) that ships with the sugtdequent product.
	If this code gives inspiration to your work, you may optionally wish to credit as such; 
		along with a description of what you improved and why.
		Feel free to also drop an email: I'm always interested in new projects.

*/






/*
	Overlay's Global Variables:
	
	I don't particularly care for global variables, but in JS they provide a reasonable trade off in terms of speed and simplicity.
	To logically contain the sprawl, all globals are kept within a single object (GtdOverlayGlobals).
*/
document.GtdOverlayGlobals = new Object();
//document.GtdOverlayGlobals.refPageDomDoc = document.documentElement;
//document.GtdOverlayGlobals.refPageDomDoc_Head = document.documentElement;
document.GtdOverlayGlobals.browser_appcontent = window.document.getElementById("appcontent");
document.GtdOverlayGlobals.GtdOptions = new GtdGmailOptions();
document.GtdOverlayGlobals.lastOptionLoadDate = 0;



function initGtdGmail(){
	/*
	On first load, hook Gtd Gmail into Mozilla
	Intention: Call 'loadGtdGmail' on every page
	*/
	
	try{

		if( !document.GtdOverlayGlobals.GmailUrlPattern ){
			document.GtdOverlayGlobals.GmailUrlPattern = new RegExp("^http([s]?)\:\/\/mail\.google\.com\/(mail|hosted)\/");
		}

		if(document.GtdOverlayGlobals.browser_appcontent){
			if (!document.GtdOverlayGlobals.browser_appcontent.gtdGmailInitialised) {
				document.GtdOverlayGlobals.browser_appcontent.gtdGmailInitialised = true;
				document.GtdOverlayGlobals.browser_appcontent.addEventListener("DOMContentLoaded", loadGtdGmail, false);
				
			}
		}
	
	}catch(e){
		//alert(e.toString());
	}
	
	
}






function loadGtdGmail(evt){
	
	/*
	Initialise some common variables
	*/

try{


	//var debugTimeStart = new Date();

	/*
	// Load Shared Objects 
	if( document.GtdOverlayGlobals.GtdOptions.getOption("bool", "SettingsReload.SharedObjects", false)==true ){
		document.GtdOverlayGlobals.GtdOptions.setOption("bool", "SettingsReload.SharedObjects", false);
		
		GtdUtilGeneral_Server.init_Browser_SharedObjects( document.GtdOverlayGlobals.browser_appcontent, true, document.GtdOverlayGlobals.GtdOptions);
	}else{
		GtdUtilGeneral_Server.init_Browser_SharedObjects( document.GtdOverlayGlobals.browser_appcontent, false, document.GtdOverlayGlobals.GtdOptions);
	}
	*/
	

	//Determine whether or not to include Sidebar:
	//GtdBrowserOverlayFunctions.handleSidebar();
	
	if(!evt.originalTarget || !evt.originalTarget.body)	return;
	
	// Short-hand location:	
	var locationHref = evt.originalTarget.location.href;

		
	// Retrieve the overlay DOM:
	//document.GtdOverlayGlobals.refPageDomDoc = evt.originalTarget;
	//document.GtdOverlayGlobals.refPageDomDoc_Head = document.GtdOverlayGlobals.refPageDomDoc.documentElement.getElementsByTagName("head")[0];

	// Prep variables:
	var pageDoc = evt.originalTarget;
	var pageDocHead = pageDoc.documentElement.getElementsByTagName("head")[0];
	var inlineScript = "";
	
	
	GtdUtilGeneral_Server.attach_StringBundle( document.GtdOverlayGlobals, "OverlayStringBundle",  "chrome://gtdgmail/locale/gtdgmail.properties");
	
	

	
	
	// Shorthand notation:
	var gtdOptions = document.GtdOverlayGlobals.GtdOptions;

	// Handle options:
	if( gtdOptions.getOption("char", "Gtd.InstallOptionsComplete", "")=="" ){
		// Set a basic option
		try{
			gtdOptions.setOption("char", "Gtd.InstallOptionsComplete", "-");
		}catch(e){}
	}
	if( gtdOptions.getOption("char", "Gtd.InstallOptionsComplete", "")!="" && gtdOptions.getOption("char", "Gtd.InstallOptionsComplete", "")!="1.22"){
		// Install the default options:
		try{
			GtdBrowserOverlayFunctions.install_Default_Options();
			// Display the side bar, so people know it's there (and can get help)
			//toggleSidebar('viewGtdGmailSidebar');
			// Show the help page in a new tab:
			
			
		}catch(e){
			//alert(e.toString());
			gtdOptions.setOption("char", "Gtd.InstallOptionsComplete", "1.22")
		}
	}
	
	// See if need to reload options:
	var lastOptionSaveDate = parseInt(gtdOptions.getOption("char", "Gtd.LastSaveOptions", "0"));
	if( document.GtdOverlayGlobals.lastOptionLoadDate==0 ){
		// Need to set first option load date for this window:
		var nowDate = new Date();
		document.GtdOverlayGlobals.lastOptionLoadDate = nowDate.getTime();
	}
	if( !isNaN(lastOptionSaveDate) && lastOptionSaveDate!=0 ){
		if( (lastOptionSaveDate > document.GtdOverlayGlobals.lastOptionLoadDate) ){
			// Need to reload the options for this window
			if(gtdOptions.getOption("bool", "Gtd.LastSaveOptions_GlobalKeysChanged", false)==true){
				// See the options js as to why this is needed. FF crashes if too much.
				Gtd_BrowserOverlay_Hotkeys.loadKeyListeners(gtdOptions);
				gtdOptions.setOption("bool", "Gtd.LastSaveOptions_GlobalKeysChanged", false);
			}
			
			var nowDate = new Date();
			document.GtdOverlayGlobals.lastOptionLoadDate = nowDate.getTime();
		}
	}
	
		


		// Partially reset hot keys:
		//document.GtdOverlayGlobals.sei_chosenEngine = "";
		
	
	try{
			
		/*
		Load Specialised Cross Pollination
		
		Retrieve the Cross Pollination object
		If this page href matches a Cross Pollination name; then inject the relevant javascript into the page.
			Then execute the driver function, injectIntoPage()
		*/
		
		//var CpSpecialisations = document.GtdOverlayGlobals.browser_appcontent.GtdShared.CpSpecialisations;
		
		// Put a place for our locale properties:
		
		
		//var didLoad = false;
		if( document.GtdOverlayGlobals.GmailUrlPattern.test( locationHref ) ){
			initDocumentObjects(pageDoc, pageDocHead);
			
			// Attach the specialised code:
			GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/GTDGmail_gtdgmail.js");
			GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/GTDGmail_Common.js");
			GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/GTDGmail_ComposeScreen.js");
			GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/GTDGmail_EmailConversationScreen.js");
			GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/GTDGmail_Filters.js");
			GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/GTDGmail_InboxData.js");
			GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/GTDGmail_LabelsAdmin.js");
			GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/GTDGmail_NavBar.js");
			GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/GTDGmail_Popup_Label.js");
			GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/GTDGmail_PrintEmails.js");
			GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/GTDGmail_SearchBar.js");
			inlineScript += "GTDGmail_gtdgmail.injectIntoPage();\n";
			
			//if( gtdOptions.getOption("bool", "debug1", false)==false ){
			//	alert("1 Gmail Boot Loader Works");
			//	gtdOptions.setOption("bool", "debug1", true);
			//}
			//didLoad = true;
		}else{

			if( locationHref=="chrome://gtdgmail/content/print_hipster_pda.htm" ){
				initDocumentObjects(pageDoc, pageDocHead);
				
				// Attach the specialised code:
				GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/print_hipster_pda.js");
				inlineScript += "Print_Hipster_PDA.injectIntoPage();\n";
				
				//didLoad = true;
			}
			if( locationHref=="chrome://gtdgmail/content/print_hipster_pda_frame_header.htm" ){
				initDocumentObjects(pageDoc, pageDocHead);
				
				// Attach the specialised code:
				GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/print_hipster_pda.js");
				inlineScript += "Print_Hipster_PDA_Header.injectIntoPage();\n";
				
				//didLoad = true;
			}
		}
		//if( locationHref.indexOf("google")>-1 && didLoad==false ){
		//	alert("failed to load gtdgmail even though it is google");
		//}
		
		//if( didLoad==true ){
		//	// Pass reference's to page DOM document
		//	GtdBrowserOverlayFunctions.copyVariableIntoPageDOM(pageDoc, "GtdTabSpecificShared", GtdTabSpecificShared);
		//}
		
		
		/*
		if( CpSpecialisations ){
			for( var i = 0; i < CpSpecialisations.CpNamesArray.length; i++ ){
				var cpName = CpSpecialisations.CpNamesArray[i];
				
				
				if( CpSpecialisations.CpObjects[cpName] ){
						var CpObject = CpSpecialisations.CpObjects[cpName];
						if( CpObject.urlPattern && CpObject.isDisabled==false && CpObject.urlPattern.test( locationHref ) ){
							// We have a winner!

							// Attach the helper code:
							//GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/Gtd_Cp_Common.js");


							// Attach the locale:
							GtdUtilGeneral_Server.attach_StringBundle( document.GtdOverlayGlobals.browser_appcontent.GtdShared.CpStringBundles, cpName,  "chrome://gtdgmail/locale/Gtd_Cp_" + cpName + ".properties");
			
							// Attach the specialised code:
							GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead, "chrome://gtdgmail/content/Gtd_Cp_" + cpName + ".js");
							inlineScript += "Gtd_Cp_" + cpName + ".injectIntoPage();\n";

							break;
						}
				}
			}
		}
		*/
		
	
	

	}catch(e){
		//alert(e.toString());
		GtdUtilGeneral_Server.write_Error(gtdOptions, "Specialised Cross Pollination:\n" + e.toString());
	}
	
	
	
	
	/*
	Final
	Embed inline script within the body portion
	*/
	if(inlineScript!=""){
		GtdUtilGeneral_Server.execute_InlineScript_PageDom(pageDoc, inlineScript);
	}
	

	


	
	

	//var debugTimeEnd = new Date();
	//alert(debugTimeEnd.getTime() - debugTimeStart.getTime());


}catch(e){
	//alert(e.toString());
}

}




var ChromeOnlyExecution = {
	
	openWindow: function(windowUrl){
		window.open(windowUrl);
	},
	
	openTab: function(windowUrl){
		GtdUtilGeneral_Server.openUrlInNewTab(windowUrl);
	},
	
	openOptions: function(){
		window.open('chrome://gtdgmail/content/gtdgmail-options.xul','gtdgmailoptions','chrome,dialog,centerscreen');
	},
	
	disableInstallationBox: function(){
		var gtdOptions = document.GtdOverlayGlobals.GtdOptions;
		
		gtdOptions.setOption("bool", "Integration.GTDNotices", false);
	}
}






	function initDocumentObjects(pageDoc, pageDocHead){
		/*
			Initiate core shared variables
		*/
		
		// Initiate Shared:
		if( !document.GtdOverlayGlobals.browser_appcontent.GtdShared ){
			document.GtdOverlayGlobals.browser_appcontent.GtdShared = new Object();
			document.GtdOverlayGlobals.browser_appcontent.GtdShared.CpStringBundles = new Object();
		}

		// Load Up Execution tool:
		document.GtdOverlayGlobals.browser_appcontent.GtdShared.ChromeOnlyExec = ChromeOnlyExecution;
		
		// Pass reference's to page DOM document
		GtdBrowserOverlayFunctions.copyVariableIntoPageDOM(pageDoc, "GtdOverlayGlobals", document.GtdOverlayGlobals);
		

		// Load common JS:
		GtdBrowserOverlayFunctions.injectCommonJavascript_PageDom(pageDoc, pageDocHead);

		// Attach the locale:
		GtdUtilGeneral_Server.attach_StringBundle( document.GtdOverlayGlobals.browser_appcontent.GtdShared.CpStringBundles, "gtdgmail",  "chrome://gtdgmail/locale/gtdgmail.properties");

		
	}



var GtdBrowserOverlayFunctions = {






	install_Default_Options: function(){
		/*
			Installed on first run (or any time prefs lost).
			Use it to set all the default options.
		*/
		var gtdOptions = document.GtdOverlayGlobals.GtdOptions;

		if( gtdOptions.getOption("char", "Gtd.InstallOptionsComplete", "")!="" && gtdOptions.getOption("char", "Gtd.InstallOptionsComplete", "")!="-" ){
			/*
				Already installed, make the iterative changes through the versions
			*/
			if( gtdOptions.getOption("char", "Gtd.InstallOptionsComplete", "")=="1.11" ){
				gtdOptions.setOption("char", "Gtd.InstallOptionsComplete", "1.2");
				try{
					gtdOptions.setOption("bool", "GTDGmail.SearchStr.OnlyInbox", false);
					gtdOptions.setOption("bool", "GTDGmail.SearchStr.SearchLabelsInsideEmail.Subject", true);
					gtdOptions.setOption("bool", "GTDGmail.SearchStr.SearchLabelsInsideEmail.Body", false);
					gtdOptions.setOption("bool", "GTDGmail.SearchStr.SearchLabelsInsideEmail.OnlyMine.ToMe", true);
					gtdOptions.setOption("bool", "GTDGmail.SearchStr.SearchLabelsInsideEmail.OnlyMine.FromMe", true);
					gtdOptions.setOption("bool", "GTDGmail.Status.UseStarForNextAction", false);
					
					gtdOptions.setOption("char", "GTDGmail.DefaultStatusLabels.NextAction", "Next Action");
					gtdOptions.setOption("char", "GTDGmail.DefaultStatusLabels.Action", "Action");
					gtdOptions.setOption("char", "GTDGmail.DefaultStatusLabels.WaitingOn", "Waiting On");
					gtdOptions.setOption("char", "GTDGmail.DefaultStatusLabels.SomeDay", "Some Day");
					gtdOptions.setOption("char", "GTDGmail.DefaultStatusLabels.Finished", "Finished");
				}catch(e){
				}
			}
			if( gtdOptions.getOption("char", "Gtd.InstallOptionsComplete", "")=="1.2" ){
				gtdOptions.setOption("char", "Gtd.InstallOptionsComplete", "1.22");
				try{
					
					gtdOptions.setOption("char", "GTDGmail.GTDStyle", "ILoveMyInbox");
					
					gtdOptions.setOption("bool", "GTDGmail.SearchStr.OnlyInbox", true);
					gtdOptions.setOption("bool", "GTDGmail.HidePrefix", true );
					gtdOptions.setOption("bool", "GTDGmail.FinishMoveToArchive", false );
					gtdOptions.setOption("bool", "GTDGmail.FinishRemovesAllStatusLabels", false );
					
					
					gtdOptions.setOption("char", "GTDGmail.DateFormat", document.GtdOverlayGlobals['OverlayStringBundle'].getString("GTDGmail.DateFormat") );
					
				}catch(e){
				}
			}
			
			// As a priority, set the new status:
			gtdOptions.setOption("char", "Gtd.InstallOptionsComplete", "1.22");
			
			GtdUtilGeneral_Server.openUrlInNewTab("chrome://gtdgmail/locale/update.htm");
			return;
		}
		

		// As a priority, set the new status:
		gtdOptions.setOption("char", "Gtd.InstallOptionsComplete", "1.22");
		
		// Now set common options:
		try{	
			gtdOptions.setOption("char", "GTDGmail_Prefix_Context", "C:");
			gtdOptions.setOption("char", "GTDGmail_Prefix_Status", "S:");
			gtdOptions.setOption("char", "GTDGmail_Prefix_Project", "P:");
			gtdOptions.setOption("char", "GTDGmail_Prefix_Reference", "R:");
			gtdOptions.setOption("char", "GTDGmail_Prefix_Old", "Old:");
			
			gtdOptions.setOption("char", "GTDGmail.DefaultStatusLabels.NextAction", "Next Action");
			gtdOptions.setOption("char", "GTDGmail.DefaultStatusLabels.Action", "Action");
			gtdOptions.setOption("char", "GTDGmail.DefaultStatusLabels.WaitingOn", "Waiting On");
			gtdOptions.setOption("char", "GTDGmail.DefaultStatusLabels.SomeDay", "Some Day");
			gtdOptions.setOption("char", "GTDGmail.DefaultStatusLabels.Finished", "Finished");
			

			gtdOptions.setOption("bool", "Integration.Labels", true);
			gtdOptions.setOption("bool", "Integration.InsertAboveNormalLabels", true);			
			gtdOptions.setOption("bool", "Integration.GTDReview", true);
			gtdOptions.setOption("bool", "Integration.GTDNotices", true);
			gtdOptions.setOption("bool", "Integration.GTDAbout", true);

			gtdOptions.setOption("bool", "Integration.GTDCompose", true);
			gtdOptions.setOption("bool", "Integration.GTDConversation", true);

			gtdOptions.setOption("bool", "Integration.GTDSearch", true);
			gtdOptions.setOption("bool", "Integration.GTDSearchCombo", true);
			gtdOptions.setOption("bool", "Integration.GTDSearchQuickSave", true);

			gtdOptions.setOption("bool", "Integration.GTDInbox", true);
			gtdOptions.setOption("bool", "Integration.GTDPrintEmails", true);

			gtdOptions.setOption("bool", "Integration.GTDLabelsAdmin", true);
			gtdOptions.setOption("bool", "Integration.GTDFiltersAdmin", true);

			gtdOptions.setOption("bool", "Integration.IncMiscLabels", false);
			
			
			gtdOptions.setOption("bool", "GTDGmail.Status.UseStarForNextAction", false);
			
			gtdOptions.setOption("bool", "GTDGmail.SearchStr.SearchLabelsInsideEmail.Subject", true);
			gtdOptions.setOption("bool", "GTDGmail.SearchStr.SearchLabelsInsideEmail.Body", false);
			gtdOptions.setOption("bool", "GTDGmail.SearchStr.SearchLabelsInsideEmail.OnlyMine.ToMe", true);
			gtdOptions.setOption("bool", "GTDGmail.SearchStr.SearchLabelsInsideEmail.OnlyMine.FromMe", true);
					
			
			gtdOptions.setOption("bool", "Integration.GTDInbox_Td_UseLogo", true);
			
			
			gtdOptions.setOption("char", "GTDReview.DaysAgo", "4");
				
			gtdOptions.setOption("char", "GTDGmail.GTDStyle", "ILoveMyInbox");
			
			gtdOptions.setOption("bool", "GTDGmail.SearchStr.OnlyInbox", true);
			gtdOptions.setOption("bool", "GTDGmail.HidePrefix", true );
			gtdOptions.setOption("bool", "GTDGmail.FinishMoveToArchive", false );
			gtdOptions.setOption("bool", "GTDGmail.FinishRemovesAllStatusLabels", false );
			
			
			gtdOptions.setOption("char", "GTDGmail.DateFormat", document.GtdOverlayGlobals['OverlayStringBundle'].getString("GTDGmail.DateFormat") );
			
			
			
		}catch(e){
			//alert(e.toString());
		}
		
		
		GtdUtilGeneral_Server.openUrlInNewTab("chrome://gtdgmail/locale/welcome.htm");		
	},
	
	

	injectCommonJavascript_PageDom: function(pageDoc, pageDocHead){
		/*
			At first hint that something advanced is happening, include all common Javascripts to the pages
		*/

		/*
		elScript = pageDoc.createElement("SCRIPT");
		elScript.setAttribute("type", 'text/javascript');
		elScript.setAttribute("src", "chrome://gtdgmail/content/gtd_general.js");
		pageDocHead.appendChild(elScript);
		*/
		
		GtdUtilGeneral_Server.attach_JavascriptSource_PageDom(pageDoc, pageDocHead,  "chrome://gtdgmail/content/gtd_general.js");
		
		
	},
	
	loadCrossPollination: function(){

		var pageDoc = GtdUtilGeneral_Server.getSelectedTabBrowser().contentDocument;

		if( pageDoc.location.href.indexOf("https://")!=-1 ){
			// It is secure, show error message to explain why it won't load.

			var strBundle = document.GtdOverlayGlobals.browser_appcontent.GtdShared.OverlayStringBundle;
			if(strBundle){
				alert( strBundle.getString("CrossPolli.Error.SecurePage") );
			}

			return;
		}


		var inlineScript = "BS_Pollination.invertDisplay();";
		inlineScript += "setTimeout(\"BS_Pollination.relatedPages_ShowHide(null, 'show', true)\", 50)"; // Load data too
		GtdUtilGeneral_Server.execute_InlineScript_PageDom(pageDoc, inlineScript);
		
	},
	
	
	copyVariableIntoPageDOM: function(pageDoc, varName, copyVar){
		/*
			Inject the shared document.GtdGlobalOverlay into the local page DOM
			
			This enables the DOM to read data established in the overlay.
		*/
		
		/*
			One potential risk is we overwrite the CpStringBundles info
			Therefore, if their is an Object already in the local pageDOM, but it has CpStringBundles
				and copyVar doesn't have CpStringBundles
				then give copyVar the old CpStringBundles
		*/
		
			
		try{
			if( pageDoc.wrappedJSObject ){
				// Security in place
				if(pageDoc.wrappedJSObject[varName]==null){
					pageDoc.wrappedJSObject[varName] = copyVar;
				}
			}else{
				if(pageDoc[varName]==null){
					pageDoc[varName] = copyVar;
				}
			}
		}catch(e){
			//alert(e.toString());
		}

	}

}












