
var GTDGmail_Common = {
	
	debug_fast_count: 0,
	debug_slow_count: 0,
	
	SharedObj: null,
		//LabelTypesObj: new Object(),
		//LabelsArray: new Array(),
		//accountEmailAddress: "",
		//accountEmailAddress_MD5: "",
		//ElLabelBox: null,
	
	
	injectCSS: function(cssName){
		/*
		Inject a chrome link to the relevant CSS file
		*/
		
		
		var docHead = document.getElementsByTagName("head")[0];
		//docHead.innerHTML += "<link rel=STYLESHEET href='" + cssName + "' type='text/css' />";
		
				
		
		var elStyle = document.createElement("LINK");
		if( !elStyle ) return;
		elStyle.setAttribute("rel", "STYLESHEET");
		elStyle.setAttribute("href", cssName);
		elStyle.setAttribute("type", "text/css");
		docHead.appendChild(elStyle);
		
	    
	},
	
	
	start: function(){
		/*
			The handling function for the entire process
			See what page we have (Based on the elements within it) and delegate accordingly
		*/
		
		// Inject the CSS:
		this.injectCSS("chrome://gtdgmail/content/Gtd_Cp_gtdgmail.css");
		
		
		// Create/Retrieve the Shared Object (for all iframes):
		if( !document.GtdOverlayGlobals.browser_appcontent.GtdShared.GtdGmail ){
			document.GtdOverlayGlobals.browser_appcontent.GtdShared.GtdGmail = new Object();
		}
		this.SharedObj = document.GtdOverlayGlobals.browser_appcontent.GtdShared.GtdGmail;
		var emailAddressStr = this.grabAndStoreEmailAddress();
		// Tie the SharedObj to this email address
		if( emailAddressStr!="" ){
			if( this.SharedObj[emailAddressStr] ){
				this.SharedObj = this.SharedObj[emailAddressStr];
			}else{
				//if( !this.SharedObj.underEmail  ){
					this.SharedObj[emailAddressStr] = new Object();
					this.SharedObj = this.SharedObj[emailAddressStr];
				//}
			}
		}
		if( !this.SharedObj.LabelTypesObj ){
			// Init the SharedObj
			this.SharedObj.Options = GtdUtilGeneral_Local.getGlobals_Overlay().GtdOptions;
			this.SharedObj.StrLocaleEntitities = document.GtdOverlayGlobals.browser_appcontent.GtdShared.CpStringBundles.gtdgmail;
			this.SharedObj.EncodeStrings = new Object();
			this.SharedObj.EncodeStrings.quoteEncode = "QpZ";
			this.SharedObj.EncodeStrings.singleQuoteEncode = "PwX";
			this.SharedObj.Compose = new Object();
			this.SharedObj.Compose.ShowElArray = ["6row_compose", "2row_compose", "1row_compose", "0row_compose", "coh_compose", "co_compose"];
			this.SharedObj.Compose.HideElArray = ["6row_compose", "2row_compose", "1row_compose", "0row_compose", "coh_compose", "co_compose"];
			this.SharedObj.LabelTypesObj = new Object();
				this.SharedObj.LabelTypesObj.Misc = new Object();
				this.SharedObj.LabelTypesObj.Misc.displayName = "Misc.";
				this.SharedObj.LabelTypesObj.Project = new Object();
				this.SharedObj.LabelTypesObj.Project.prefix = this.SharedObj.Options.getOption("char", "GTDGmail_Prefix_Project", "P:");
				this.SharedObj.LabelTypesObj.Project.displayName = "Projects";
				this.SharedObj.LabelTypesObj.Project.toolTip = "A Project is used to group related tasks/emails together.";
				this.SharedObj.LabelTypesObj.Reference = new Object();
				this.SharedObj.LabelTypesObj.Reference.prefix = this.SharedObj.Options.getOption("char", "GTDGmail_Prefix_Reference", "R:");
				this.SharedObj.LabelTypesObj.Reference.displayName = "References";
				this.SharedObj.LabelTypesObj.Reference.toolTip = "A Reference is a non-actionable item; e.g. a file, a note or a link to a website.";
				this.SharedObj.LabelTypesObj.Status = new Object();
				this.SharedObj.LabelTypesObj.Status.prefix = this.SharedObj.Options.getOption("char", "GTDGmail_Prefix_Status", "S:");
				this.SharedObj.LabelTypesObj.Status.displayName = "Statuses";
				this.SharedObj.LabelTypesObj.Status.toolTip = "A Status lets a task/email be actionable, waiting on somebody else, or deferred for later.";
				this.SharedObj.LabelTypesObj.Context = new Object();
				this.SharedObj.LabelTypesObj.Context.prefix = this.SharedObj.Options.getOption("char", "GTDGmail_Prefix_Context", "C:");
				this.SharedObj.LabelTypesObj.Context.displayName = "Contexts";
				this.SharedObj.LabelTypesObj.Context.toolTip = "A Context is where a Task will be done, e.g. phone, computer, in town, etc.";
				this.SharedObj.LabelTypesObj.Old = new Object();
				this.SharedObj.LabelTypesObj.Old.prefix = this.SharedObj.Options.getOption("char", "GTDGmail_Prefix_Old", "Old:");				
			this.SharedObj.StandardLabels = new Object();
				//this.SharedObj.StandardLabels.Finished = this.SharedObj.LabelTypesObj.Finished.prefix + "Finished";
				this.SharedObj.StandardLabels.Reference = new Object();
				this.SharedObj.StandardLabels.Reference.Reference = this.SharedObj.LabelTypesObj.Reference.prefix + "Reference";
				this.SharedObj.StandardLabels.Reference.ProjectHome = this.SharedObj.LabelTypesObj.Reference.prefix + "ProjectHome";
				this.SharedObj.StandardLabels.Context = new Object();
				this.SharedObj.StandardLabels.Context.ContextArray = ["Computer", "Phone", "Car", "Home", "Office"];
				this.SharedObj.StandardLabels.Context.Computer = this.SharedObj.LabelTypesObj.Context.prefix + "Computer";
				this.SharedObj.StandardLabels.Context.Phone = this.SharedObj.LabelTypesObj.Context.prefix + "Phone";
				this.SharedObj.StandardLabels.Context.Car = this.SharedObj.LabelTypesObj.Context.prefix + "Car";
				this.SharedObj.StandardLabels.Context.Home = this.SharedObj.LabelTypesObj.Context.prefix + "Home";
				this.SharedObj.StandardLabels.Context.Office = this.SharedObj.LabelTypesObj.Context.prefix + "Office";
				this.SharedObj.StandardLabels.Status = new Object();
				this.SharedObj.StandardLabels.Status.StatusArray = ["NextAction", "Action", "WaitingOn", "Someday", "Finished"];
				this.SharedObj.StandardLabels.Status.NextAction = this.SharedObj.LabelTypesObj.Status.prefix + this.SharedObj.Options.getOption("char", "GTDGmail.DefaultStatusLabels.NextAction", "Next Action");
				this.SharedObj.StandardLabels.Status.Action = this.SharedObj.LabelTypesObj.Status.prefix + this.SharedObj.Options.getOption("char", "GTDGmail.DefaultStatusLabels.Action", "Action");
				this.SharedObj.StandardLabels.Status.WaitingOn = this.SharedObj.LabelTypesObj.Status.prefix + this.SharedObj.Options.getOption("char", "GTDGmail.DefaultStatusLabels.WaitingOn", "Waiting On");
				this.SharedObj.StandardLabels.Status.Someday = this.SharedObj.LabelTypesObj.Status.prefix + this.SharedObj.Options.getOption("char", "GTDGmail.DefaultStatusLabels.SomeDay", "Some Day");
				this.SharedObj.StandardLabels.Status.Finished = this.SharedObj.LabelTypesObj.Status.prefix + this.SharedObj.Options.getOption("char", "GTDGmail.DefaultStatusLabels.Finished", "Finished");
			this.SharedObj.LabelsObj = new Object();
				this.SharedObj.LabelsObj.Misc = new Object();
				this.SharedObj.LabelsObj.Project = new Object();
				this.SharedObj.LabelsObj.Reference = new Object();
				this.SharedObj.LabelsObj.Status = new Object();
				this.SharedObj.LabelsObj.Context = new Object();
				this.SharedObj.LabelsObj.Old = new Object();
				// Prep labels Arrays:
				var Types = ["Misc", "Project", "Reference", "Status", "Context", "Old"];
				for( var i = 0; i < Types.length; i++ ){
					if( !GTDGmail_Common.SharedObj.LabelsObj[Types[i]].LabelArray ){
						GTDGmail_Common.SharedObj.LabelsObj[Types[i]].LabelArray = new Array();
					}
				}
			//this.SharedObj.accountEmailAddress = "";
			//this.SharedObj.documentObjects = new Object();
			//	this.SharedObj.documentObjects.NavBar = null;
			this.SharedObj.Search = new Object();
				this.SharedObj.Search.ElTextBox = null;
				this.SharedObj.Search.ElButton = null;
				
		}
		
		

		
		// Seperate thread:
		
		//if( GTDGmail_Popup_Label.pageHasInbox() ){
		//	alert("2 begin integrating");
		//}
		setTimeout("GTDGmail_Common.guiRefresh(0);GTDGmail_Common.guiRefresh_Slow();", 50);

		
		
		//StaticTimerPoll.poll();
	},
	
	grabAndStoreEmailAddress: function(){

		try{
			if( document.getElementById("hlp") ){
				// We can get the email address
				var ElHook = document.getElementById("hlp");
				ElHook = ElHook.parentNode;
				var emailAddressStr = ElHook.firstChild.innerHTML;
				
				// Store it in Options
				GtdUtilGeneral_Local.getGlobals_Overlay().GtdOptions.setOption("char", "CurrentEmailAddress", emailAddressStr);
				
				
				return emailAddressStr;
			}
		}catch(e){
			//alert(e.toString() + "\nGTDGmail_Common");
		}

	},
	
	guiRefresh: function(counter){

		//document.title = this.debug_fast_count++ + this.debug_slow_count;

		var didUpdate = false;
				
		//var Et = new ExecutionTimer("1");
		//Et.start();
				
		if( GTDGmail_NavBar.pageHasFreshNavBar() ){
			// Retrieve the Nav Bar document:
			
					
			// Alter the nav bar:			
			GTDGmail_NavBar.handleLabels(0, true);
			didUpdate = true;
		}
		
		if( GTDGmail_Popup_Label.pageHasInbox() ){
			// It's Inbox or Search Results

			if( GTDGmail_Popup_Label.pageHasInbox() && GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.GTDInbox", false) ){
				GTDGmail_Popup_Label.handleInbox();
				didUpdate = true;
			}
			
			
			if( GTDGmail_PrintEmails.hasEmails() && GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.GTDPrintEmails", false) ){
				GTDGmail_PrintEmails.handleEmails();
				didUpdate = true;
			}
			
		}else{
			// Not inbox
		}		

			
		if( didUpdate ){
			
			if( counter < 6 ){
				counter++;
				setTimeout("GTDGmail_Common.guiRefresh(" + counter + ")", 2000);
			}else{
				setTimeout("GTDGmail_Common.guiRefresh(10)", 6000);
			}
		}

		//Et.stop();
		//if( Et.getDuration() > 50 ){
			//Et.announce();
		//}
	},
	guiRefresh_Slow: function(){
		
				
		var didUpdate = false;
		
		

		if( GTDGmail_SearchBar.pageHasFreshSearchBar() ){
			// Retrieve search details
			// Update search box
			GTDGmail_SearchBar.handleSearchBar();
			didUpdate = true;
		}
		
		
		if( !GTDGmail_Popup_Label.pageHasInbox() ){
		
			if( GTDGmail_EmailConversationScreen.pageHasFreshEmailConversation() && GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.GTDConversation", false) ){
				GTDGmail_EmailConversationScreen.handleMailConversation();
				didUpdate = true;
			}
			
			if( GTDGmail_ComposeScreen.pageHasFreshComposeDetails() && GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.GTDCompose", false) ){
				GTDGmail_ComposeScreen.handleCompose();
				didUpdate = true;
			}	
			
			if( GTDGmail_LabelsAdmin.pageHasLabelsAdmin() && GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.GTDLabelsAdmin", false) ){
				GTDGmail_LabelsAdmin.handleLabelsAdmin();
				didUpdate = true;
			}
			
			if( GTDGmail_Filters.pageHasFilters() && GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.GTDFiltersAdmin", false) ){
				GTDGmail_Filters.handleFilters();
				didUpdate = true;
			}
		
		}
		
		if( didUpdate ){
			setTimeout("GTDGmail_Common.guiRefresh_Slow()", 10000);
		}

		//Et.stop();
		//if( Et.getDuration() > 50 ){
			//Et.announce();
		//}
	},
	

	hideShowHideElements: function(){
		/*
			Called just after a Nav Bar or other area is first loaded
			Process the elements to see what needs hiding (if anything)
		*/
		//var eTimer = new ExecutionTimer("HideElements");
		//eTimer.start();
		
		var idArray = this.SharedObj.Options.getOption("char", "GTDGmail_ShowHide_Hidden", "").split(",");
		for( var i = 0; i < idArray.length; i++ ){
			if( idArray[i]!="" ){
				var ElShowHideLink = document.getElementById(idArray[i]);
				if(ElShowHideLink){
					ElShowHideLink.setAttribute("next", "hide");	//Make sure it's set to hide
					this.clickHandler_ShowHide(ElShowHideLink, true);
				}
				ElShowHideLink = null;
			}
		}
		idArray = null;
		
		//eTimer.stop();
	},
	updateShowHideElementsHiddenStatus: function(showHide, elementId){
		/*
			Marks whether a ShowHide element should be Hidden on the next load
			This is stored in a string in the Options: <elId1>,<elId2>,
			Specifically, the elements are the showhide Links
			If show:
				Parse list and rebuild it, stripping out any cases of ID
			If hide:
				Add it to the list
		*/
		
		// The New Options String:
		var newHiddenStr = "";
		
		// Rebuild list (without this element):
		var idArray = this.SharedObj.Options.getOption("char", "GTDGmail_ShowHide_Hidden", "").split(",");
		for( var i = 0; i < idArray.length; i++ ){
			if( idArray[i].length < 40 ){
				if( idArray[i]!=elementId && idArray[i]!="" ){
					newHiddenStr += idArray[i] + ",";
				}
			}
		}
		if( showHide=="hide" ){
			// Append us:
			newHiddenStr += elementId + ",";
		}
		
		// Write it out to the options:
		this.SharedObj.Options.setOption("char", "GTDGmail_ShowHide_Hidden", newHiddenStr);
		
		newHiddenStr = null;
	},
	clickHandler_ShowHide: function(ElShowHideLink, bool_suppressUpdate){
		try{
			var elToShowHideStr = ElShowHideLink.getAttribute("elToShowHide");
			if( elToShowHideStr=="" ){
				return;
			}
			
			var ElToShowHide = document.getElementById(elToShowHideStr);
			if(!ElToShowHide) return;
			
			//var ElOldLabels = document.getElementById("Div_GTDLabelBox_OldLabels");
			//var ElShowHideLink = document.getElementById("Link_GTDLabelBox_Type_OldLabels");
			
			var nextAction = ElShowHideLink.getAttribute("next");
			if( nextAction=="show" ){
				// Show it
				ElShowHideLink.setAttribute("next", "hide");
				ElToShowHide.style.display = "";
				ElShowHideLink.innerHTML = ElShowHideLink.getAttribute("textHide");
				
				if( !bool_suppressUpdate ){
					this.updateShowHideElementsHiddenStatus("show", ElShowHideLink.id);
				}
			}else{
				// Hide it
				ElShowHideLink.setAttribute("next", "show");
				ElToShowHide.style.display = "none";
				ElShowHideLink.innerHTML = ElShowHideLink.getAttribute("textShow");
				
				if( !bool_suppressUpdate ){
					this.updateShowHideElementsHiddenStatus("hide", ElShowHideLink.id);
				}
			}
			
			elToShowHideStr = null;
			ElToShowHide = null;
			ElShowHideLink = null;
		}catch(e){
			//alert(e.toString() + "\nGTDGmail_Common");
		}
	},

	
	testLabelInUse: function(typeStr, labelName){
		/*
			Scan the relevant Type label array to see if the desired label is present
			True if it is
		*/
				
		if( GTDGmail_Common.SharedObj.LabelsObj[typeStr] ){
			for( var i = 0; i < GTDGmail_Common.SharedObj.LabelsObj[typeStr].LabelArray.length; i++ ){
				if( labelName==GTDGmail_Common.SharedObj.LabelsObj[typeStr].LabelArray[i] ){
					return true;
				}
			}
		}
		
		return false;
	},
	
	removeLabelPrefix: function(label){
		/*
			Return the label, without any prefix
		*/
	
		if( GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.HidePrefix", false) ){
			var LabelTypesObj = GTDGmail_Common.SharedObj.LabelTypesObj;
			var prefixes = [LabelTypesObj.Status.prefix, LabelTypesObj.Context.prefix, LabelTypesObj.Project.prefix, LabelTypesObj.Reference.prefix, LabelTypesObj.Old.prefix];
			
			for( var i = 0; i < prefixes.length; i++ ){
				// Create regexp for this prefix:
				prefixes[i] = prefixes[i].replace(/(\W)/g, "\\$1");
				var PrefixRegExp = new RegExp("^" + prefixes[i]);
				if( PrefixRegExp.test( label ) ){
					return label.replace( PrefixRegExp, "");
				}
			}
		}
		
		return label;
	},
	removeLabelPrefix_Known: function(prefix, label){
		if( GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.HidePrefix", false) ){
			return label.replace(prefix, "");
		}else{
			return label;
		}
	},
	
	getCommonSearchTermStr: function(excludeInboxOnly){
		/*
			Depending on the settings, return a search string that is true to every search
				-in:spam
				in:inbox
				
			excludeInboxOnly is used to never allow 'in:inbox'
				S:Some Day uses this
		*/
		
		var searchStr = "";
		searchStr = " -in:spam";
		
		if( !excludeInboxOnly && GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.SearchStr.OnlyInbox", false)==true ){
			// Add an extra part to the search to ensure only in inbox
			searchStr += " in:inbox";
		}
		

				
		return searchStr;
	},
	getCommonSearchStr_SearchLabelsInEmail: function(labelName){
		labelName = labelName.replace(/[ &]/g, "-");
		var searchStr = "";
		
		var searchInSubject = GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.SearchStr.SearchLabelsInsideEmail.Subject", false);
		var searchInBody = GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.SearchStr.SearchLabelsInsideEmail.Body", false);
		if( searchInSubject || searchInBody ){
			var emailAddress = GTDGmail_Common.SharedObj.Options.getOption("char", "CurrentEmailAddress", "");
			emailAddress = emailAddress.replace("@", " ");
			
			searchStr += " OR (";
			
			if( searchInSubject ){
				searchStr += "subject:\"" + labelName + "\"";
			}
			if( searchInBody ){
				searchStr += " \"" + labelName + "\"";
			}
			if( emailAddress!="" ){
				if( GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.SearchStr.SearchLabelsInsideEmail.OnlyMine.ToMe", false) ){
					searchStr += " to:(" + emailAddress + ")";
				}
				if( GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.SearchStr.SearchLabelsInsideEmail.OnlyMine.FromMe", false) ){
					searchStr += " from:(" + emailAddress + ")";
				}
			}
			
			searchStr += ")";
		}
		return searchStr;
	},
	
	encodeQuotes: function(str){
		str = str.replace(/'/g, this.SharedObj.EncodeStrings.singleQuoteEncode);
		str = str.replace(/"/g, this.SharedObj.EncodeStrings.quoteEncode);
		
		return str;
	},
	
	replaceAll: function( str, from, to ) {
		var idx = str.indexOf( from );


		while ( idx > -1 ) {
			str = str.replace( from, to );
			idx = str.indexOf( from );
		}

		return str;
	},
	
	renderStandardStatuses_InOrder: function(htmlTemplatePresent, htmlTemplateNotPresent, bool_incNonStandardLabels, ExcludeLabelsArray){
		/*
			Go over the standard statuses
			If found in known labels,
				Replace htmlTemplatePresent <!StatusId!> <!StatusLabel!> with StatusID and StatusLabel respectively
			If NOT found in known labels,
				Replace htmlTemplateNotPresent <!StatusId!> <!StatusLabel!> with StatusID and StatusLabel respectively
		*/
		
		var boolContains_SearchLabelInEmailEncodeQuotesNoSpace = false;
		if( htmlTemplatePresent.indexOf("<!SearchLabelInEmailEncodeQuotesNoSpace!>") > -1 ){
			boolContains_SearchLabelInEmailEncodeQuotesNoSpace = true;
		}
		if( htmlTemplateNotPresent.indexOf("<!SearchLabelInEmailEncodeQuotesNoSpace!>") > -1 ){
			boolContains_SearchLabelInEmailEncodeQuotesNoSpace = true;
		}
		
		try{
			var statusPrefix = GTDGmail_Common.SharedObj.LabelTypesObj.Status.prefix;
		
			var newLine = "";
			var returnStr = "";	
			var StandardLabelsArray = new Array();
			for( var i = 0; i < this.SharedObj.StandardLabels.Status.StatusArray.length; i++ ){
				var statusId = this.SharedObj.StandardLabels.Status.StatusArray[i];
				
				var statusLabel = this.SharedObj.StandardLabels.Status[statusId];
			
				var statusLabelNoPrefix = this.removeLabelPrefix_Known(statusPrefix, statusLabel);
			
				var statusLabelNoSpace = statusLabel.replace(/[ &]/g, "-");
				var StatusLabelEncodeQuotesNoSpace = this.encodeQuotes(statusLabelNoSpace);
				
				var searchLabelInEmail = "";
				if( boolContains_SearchLabelInEmailEncodeQuotesNoSpace ){
					searchLabelInEmail = this.encodeQuotes(this.getCommonSearchStr_SearchLabelsInEmail(statusLabelNoSpace));
				}
				
				
				StandardLabelsArray[StandardLabelsArray.length] = statusLabel;
				if( ExcludeLabelsArray==null || !this.arrayContains( ExcludeLabelsArray, statusLabel ) ){
					
					if( this.testLabelInUse( "Status", statusLabel ) ){
						// We have it
						newLine = htmlTemplatePresent.replace(/\<\!StatusId\!\>/gi, statusId);
					}else{
						// We have it
						newLine = htmlTemplateNotPresent.replace(/\<\!StatusId\!\>/gi, statusId);
					}
					newLine = newLine.replace(/\<\!StatusLabel\!\>/gi, statusLabel);
					newLine = newLine.replace(/\<\!StatusLabelNoSpace\!\>/gi, statusLabelNoSpace);
					newLine = newLine.replace(/\<\!StatusLabelNoPrefix\!\>/gi, statusLabelNoPrefix );
					newLine = newLine.replace(/\<\!StatusLabelEncodeQuotesNoSpace\!\>/gi, StatusLabelEncodeQuotesNoSpace);
					newLine = newLine.replace(/\<\!SearchLabelInEmailEncodeQuotesNoSpace\!\>/gi, searchLabelInEmail);
					
					if( statusId=="Someday" ){
						// Disable inbox only
						newLine = newLine.replace(/\<\!XtraSearchStr\!\>/gi, this.getCommonSearchTermStr(true) );
					}else{
						newLine = newLine.replace(/\<\!XtraSearchStr\!\>/gi, this.getCommonSearchTermStr() );
					}
					
					returnStr += newLine;
				}
			}
			
			if( bool_incNonStandardLabels==true ){
				for( var i = 0; i < GTDGmail_Common.SharedObj.LabelsObj.Status.LabelArray.length; i++ ){
					newLine = "";
					
					// Check this label isn't already in known Status array:
					var labelName = GTDGmail_Common.SharedObj.LabelsObj.Status.LabelArray[i];
    				var labelNameNoSpace  = labelName.replace(/ /g, '-');
    				var labelNameNoPrefix = this.removeLabelPrefix_Known(statusPrefix, labelName);
					var StatusLabelEncodeQuotesNoSpace = this.encodeQuotes(labelNameNoSpace)
					
					var searchLabelInEmail = "";
					if( boolContains_SearchLabelInEmailEncodeQuotesNoSpace ){
						searchLabelInEmail = this.encodeQuotes(this.getCommonSearchStr_SearchLabelsInEmail(labelNameNoSpace));
					}
					
					if( ExcludeLabelsArray==null || !this.arrayContains( ExcludeLabelsArray, labelName ) ){
						if( !GTDGmail_Common.arrayContains(StandardLabelsArray, labelName) ){
							// Not Already Processed
							newLine = htmlTemplatePresent.replace(/\<\!StatusId\!\>/gi, statusId);
							newLine = newLine.replace(/\<\!StatusLabel\!\>/gi, labelName);
							newLine = newLine.replace(/\<\!StatusLabelNoSpace\!\>/gi, labelNameNoSpace);
							newLine = newLine.replace(/\<\!StatusLabelNoPrefix\!\>/gi, labelNameNoPrefix);
							newLine = newLine.replace(/\<\!StatusLabelEncodeQuotesNoSpace\!\>/gi, StatusLabelEncodeQuotesNoSpace);
							newLine = newLine.replace(/\<\!SearchLabelInEmailEncodeQuotesNoSpace\!\>/gi, searchLabelInEmail);
							
							newLine = newLine.replace(/\<\!XtraSearchStr\!\>/gi, this.getCommonSearchTermStr() );
						}
						returnStr += newLine;
					}
				}
			}
			
			if( GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.Status.UseStarForNextAction", false) ){
				// Using stars for next action
				returnStr = GTDGmail_Common.replaceAll(returnStr, "label:" + GTDGmail_Common.SharedObj.StandardLabels.Status.NextAction.replace(/[ &]/g, "-"), "is:starred");
			}
			
			return returnStr;
		}catch(e){
			//alert(e.toString() + "\nGTDGmail_Common");
		}
	},
	
	doClickEvent: function(ElToClick){
		var clickEvent = document.createEvent('MouseEvents');
		clickEvent.initMouseEvent('click', true, true, document.defaultView, 1, 0, 0, 0, 0, false, false, false, false, 0, null); 
		ElToClick.dispatchEvent( clickEvent );
	},
	doMouseEvent: function(ElToClick, eventType){
		var clickEvent = document.createEvent('MouseEvents');
		clickEvent.initMouseEvent(eventType, true, true, document.defaultView, 1, 0, 0, 0, 0, false, false, false, false, 0, null); 
		ElToClick.dispatchEvent( clickEvent );
	},
	doHtmlEvent: function(ElToEvent, eventType){
		var clickEvent = document.createEvent('HTMLEvents');
		clickEvent.initEvent(eventType, true, true); 
		ElToEvent.dispatchEvent( clickEvent );	
	},
	
	
	
	loadIframe: function(iframeId, iframeUrl){
		var ElIframe = document.getElementById(iframeId);
		
		if( ElIframe && ElIframe.style.display!="none" ){
			ElIframe.setAttribute("src", iframeUrl);
		}
		
	},
	
	
	arrayContains: function(TheArray, lookupValue){
		if( TheArray && TheArray.length ){
			for( var ii = 0; ii < TheArray.length; ii++ ){
				if( TheArray[ii]==lookupValue ){
					return true;
				}
			}
		}
		return false;
	},
	
	one_week_ago: function() {
		return this.x_days_ago("7");
	},
	x_days_ago: function(daysAgoStr){
		var daysAgo = daysAgoStr.valueOf();
		
		var sdate = new Date();

		// figure out day, month, year 7 days ago		
		var odate = new Date(sdate.getTime() - (daysAgo * 86400000));

		// return value
		return this.getFormattedDate(odate);
	},
	getFormattedDate: function(odate){
		var dateFormat = GTDGmail_Common.SharedObj.Options.getOption("char", "GTDGmail.DateFormat", "");
		
		if( dateFormat=="UK" ){		
			return odate.getFullYear() + '/' + (odate.getMonth()+1) + '/' + odate.getDate();	
		}
		if( dateFormat=="US" ){		
			return odate.getFullYear() + '/' + odate.getDate() + '/' + (odate.getMonth()+1);	
		}
	},
}
