
var GTDGmail_EmailConversationScreen = {

	lastStarStatus: false,
	timerActive: false,

	pageHasFreshEmailConversation: function(){
		var ElMsgs = document.getElementById("msgs");
		var ElCform = document.getElementById("compose_form");
				
		if( ElMsgs && ElCform ){
			return true;
		}else{
			return false;
		}
	},
	
	/*
	timerDetectStarChange: function(){
		/*
			Detect if there has been a status change on the star
			If star is activated, drop all other statuses
		/
		
		//alert("ping");
		try{
			if( !this.timerActive ){
				this.timerActive = true;	// stop it being activated again
				this.lastStarStatus = this.convoHasStar();
			}else{
				if( this.lastStarStatus!=this.convoHasStar() ){
					// Status Change
					this.lastStarStatus = this.convoHasStar();
					
					if( this.lastStarStatus==true ){
						// Remove all other labels
						var ElSelect = document.getElementById("ctam");
						this.removeStatusLabels(ElSelect);
						this.handleMailConversation();
					}
				}
			}
		}catch(e){
			//alert(e.toString());
		}
		
		
		
		
		if( this.pageHasFreshEmailConversation() ){
			setTimeout("GTDGmail_EmailConversationScreen.timerDetectStarChange();", 2000);
		}
	},
	*/
	
	handleMailConversation: function(refreshLabelBox){
		/*
			Inject a DIV box into the page just before the 'msgs' (conversation) element - after title
			
			DIV	[margin-left; no border]
				TABLE [left col is the Type in bold, right col is the labels not already in use]
			
			
		*/
		
		//var eTimer = new ExecutionTimer("HandleLabels");
		//eTimer.start();
		
		try{
			
			// Read in Conversation Labels:
			var ElSelect = document.getElementById("ctam");
			GTDGmail_Common.doMouseEvent(ElSelect, 'mouseover');
			
			var ConvoLabelsArray = new Array();	// The labels the conversation has
			for( var i = 0; i < ElSelect.childNodes.length; i++ ){
				var optionValue = ElSelect.childNodes[i].value;
				if( optionValue.indexOf("rc_")!=-1 ){
					// This is a label
					ConvoLabelsArray[ ConvoLabelsArray.length ] = optionValue.replace(/rc\_/i, "");
				}
			}
			
			
						
			var ElMsgs = document.getElementById("msgs");
			
			// CREATE THE NEW LABELS BOX:
			// Create the DIV:
			var ElConvo_Labels = document.getElementById("GTDConversation_LabelsBox");
			if( ElConvo_Labels && refreshLabelBox ){
				ElConvo_Labels.innerHTML = "";
			}
			if( !ElConvo_Labels || ElConvo_Labels.innerHTML=="" ){
				// ALLOW OLD LABELS TO BE EASILY ZAPPED
				/*
					Process each Label on the interface (SPAN)
					For each, if no existing processing, update the SPAN to include (x)
						where x is a hyperlink to AddRemoveLabels + reload this
				*/
				var ElCurrentLabels = document.getElementById("tt");
				var firstOne = true;
				for( var i = 0; i < ElCurrentLabels.childNodes.length; i++ ){
					if( ElCurrentLabels.childNodes[i].nodeName.toLowerCase()=="span" ){
						// We have a span:
						var spanId = ElCurrentLabels.childNodes[i].id;
						//alert(spanId);
						if( spanId.indexOf("sc_")!=-1 ){
							// This is a label
							var labelName = spanId.replace("sc_", "");
							if( ElCurrentLabels.childNodes[i].innerHTML.indexOf( "item=\"" + labelName + "\"" )==-1 ){
							//if( !document.getElementById("labelchild_" + labelName) ){
								// Not already in
								// See if need to remove prefix:
								ElCurrentLabels.childNodes[i].innerHTML = GTDGmail_Common.removeLabelPrefix( ElCurrentLabels.childNodes[i].innerHTML );
								if(!firstOne){
									ElCurrentLabels.childNodes[i].innerHTML = "<span> - </span>" + ElCurrentLabels.childNodes[i].innerHTML;
								}
								ElCurrentLabels.childNodes[i].innerHTML = ElCurrentLabels.childNodes[i].innerHTML + " <span id='labelchild_" + labelName + "' style='font-size:0.8em;color:black;position:relative;top:1px;'>[<a href='' onclick=\"GTDGmail_EmailConversationScreen.clickHandler_AddRemoveLabel(this, 'remove');GTDGmail_EmailConversationScreen.handleMailConversation();return false;\" item=\"" + labelName + "\"  style='color:rgb(204,28,15);font-family:verdana;' title='Remove this Label from the Conversation'>X</a>]</span>";
								firstOne = false;
							}
						}
					}
				}
			
			
				if( !ElConvo_Labels ){
					// Create it
					ElConvo_Labels = document.createElement("DIV");
					ElConvo_Labels.id = "GTDConversation_LabelsBox";
					ElConvo_Labels.className = "GTDConversations_LabelsBox";
					// Add it [before msgs element]
					ElMsgs.parentNode.insertBefore(ElConvo_Labels, ElMsgs);
				}
				
				var innerHTML = "";
				innerHTML += "<span class='GTDConversations_LabelsBox_Info'>Assign a GTD Label to this Conversation:"
				innerHTML += "&nbsp;<a id='GTDConversations' href='' onclick=\"GTDGmail_Common.clickHandler_ShowHide(this, false);return false;\" next='hide' elToShowHide='GTDConversations_Table' textShow='[Show]' textHide='[Hide]' class='' >[Hide]</a>";
				innerHTML += "</span>";
				//Create Table [Type on the left, Labels on the right]
				innerHTML += "<table id='GTDConversations_Table' cellpadding='0' cellspacing='0' title='Click to add the Label to this Conversation'>";
				
				// Add statuses:
				if( GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.Status.UseStarForNextAction", false) ){
					// Using Stars for Next Action - make sure Next Action label not shown
					ConvoLabelsArray[ConvoLabelsArray.length] = GTDGmail_Common.SharedObj.StandardLabels.Status.NextAction;
				}
				var labelStr = GTDGmail_Common.renderStandardStatuses_InOrder( this.getHtml_AddLabelLink("<!StatusId!>", "<!StatusLabel!>", "<!StatusLabelNoPrefix!>") + ", ", "", true, ConvoLabelsArray);
				if( labelStr!="" ){
					// Remove final comma
					labelStr = labelStr.replace(/, $/, "");
					innerHTML += "<tr><td>" + GTDGmail_Common.SharedObj.LabelTypesObj.Status.displayName + ":</td><td>&nbsp;</td><td>" + labelStr + "</td></tr>";
				}
				
				var foundOne = false;
				var Types = ["Context", "Project", "Reference", "Misc", "Old"];
				for( var i = 0; i < Types.length; i++ ){
					var typeStr = Types[i];
					if( typeStr.toLowerCase()!="old" ){
						var typeName = GTDGmail_Common.SharedObj.LabelTypesObj[typeStr].displayName;
						var typePrefix = GTDGmail_Common.SharedObj.LabelTypesObj[typeStr].prefix;
						var labelStr = "";
						var LabelsArray = GTDGmail_Common.SharedObj.LabelsObj[typeStr].LabelArray;
						// Build up the labelStr:
						for( var j = 0; j < LabelsArray.length; j++ ){
							// Make sure label isn't already in use:
							if( !GTDGmail_Common.arrayContains(ConvoLabelsArray, LabelsArray[j]) ){
								if( labelStr!="" ){
									labelStr = labelStr + ", ";
								}
								var labelName = LabelsArray[j];
								var labelDisplayName = GTDGmail_Common.removeLabelPrefix_Known(typePrefix, labelName);
								labelStr += this.getHtml_AddLabelLink( labelName.replace(/[\W]/g, ""), labelName, labelDisplayName );
							}
						}
						
						// Now add the row:
						if( labelStr!="" ){
							foundOne = true;
							if( typeStr=="Misc" ){
								// Use alternate style
								innerHTML += "<tr><td><div class='GTDMisc'>" + typeName + ":</div></td><td>&nbsp;</td><td><div class='GTDMisc'>" + labelStr + "</div></td></tr>";
							}else{
								innerHTML += "<tr><td>" + typeName + ":</td><td>&nbsp;</td><td>" + labelStr + "</td></tr>";
							}
						}
					}
				}
				innerHTML += "</table>";
				
				if( foundOne == true ){
					ElConvo_Labels.innerHTML = innerHTML;
					this.boldenProjectsFoundInText();
				}
			}
			
			
			// Pushed the adverts down, if they're overlapping
			var ElAds = document.getElementById("rh");
			if( ElAds && !ElAds.hasAttribute("isAdjusted") ){
				var topInt = parseInt(ElAds.style.top);
				ElAds.style.top = topInt + 20 + "px";
				ElAds.setAttribute("isAdjusted", "yes");
				ElAds = null;
			}
		
		}catch(e){
			//alert(e.toString());
		}
		
		/*
		if( !this.timerActive ){
			// Start timer
			this.timerDetectStarChange();
		}
		*/
		
		//eTimer.stop();
		//eTimer.announce();
		
	},
	getHtml_AddLabelLink: function(labelId, labelName, labelDisplayName){
		return "<a id='GTDConversations_AddLabel_" + labelId + "' href='' class='GTDConversations_LabelsBox_LabelLink' onclick=\"GTDGmail_EmailConversationScreen.clickHandler_AddRemoveLabel(this, 'add');GTDGmail_EmailConversationScreen.handleMailConversation();return false;\" item=\"" + labelName + "\" >" + labelDisplayName + "</a>";
	},
	
	boldenProjectsFoundInText: function(){
		try{
			var ElMsgs = document.getElementById("msgs");
			var ProjectsArray = GTDGmail_Common.SharedObj.LabelsObj["Project"].LabelArray;
			var typePrefix = GTDGmail_Common.SharedObj.LabelTypesObj["Project"].prefix;
			for( var i = 0; i < ProjectsArray.length; i++ ){
				// Get Project Label
				var labelId = ProjectsArray[i].replace(/[\W]/g, "")
				var labelDisplayName = ProjectsArray[i].replace(typePrefix, "");

				// See if it is in the page
				if( ElMsgs.innerHTML.replace(/\<([^>]+)\>/g, "").indexOf( labelDisplayName )!=-1 ){
					// In Page, grab element and make it bold
					var ElLink = document.getElementById("GTDConversations_AddLabel_" + labelId);
					if( ElLink ){
						ElLink.innerHTML = "<strong>" + ElLink.innerHTML + "</strong>";
					}
				}

			}
		}catch(e){
			//alert(e.toString());
		}
		
	},
	
	convoHasStar: function(){
		/* Return true if this conversation is starred
			Check the drop down box
			if it contains a label to remove a star (Option value=xst), this is starred
		*/
		
		var ElSelect = document.getElementById("ctam");
		GTDGmail_Common.doMouseEvent(ElSelect, 'mouseover');
		
		for( var i = 0; i < ElSelect.childNodes.length; i++ ){
			if( ElSelect.childNodes[i].nodeName.toLowerCase()=="option" ){
				if( ElSelect.childNodes[i].value=="st" ) return false;
				if( ElSelect.childNodes[i].value=="xst" ) return true;
			}
		}
		
		return false;
	},
	convoSetStar: function(starOn){
		/*
			Navigate the More Actions drop down
				If starOn
					find option with value st and click it
				If !starOn
					find option with value xst and click it
		*/
		
		var ElSelect = document.getElementById("ctam");
		GTDGmail_Common.doMouseEvent(ElSelect, 'mouseover');
		
		var optionCount = 0;
		for( var i = 0; i < ElSelect.childNodes.length; i++ ){
			if( ElSelect.childNodes[i].nodeName.toLowerCase()=="option" ){
				if( ElSelect.childNodes[i].value=="st" ){
					if( starOn ){
						// Click it to add
						ElSelect.selectedIndex = optionCount;
						GTDGmail_Common.doHtmlEvent(ElSelect, "change");
					}
					return;
				}
				if( ElSelect.childNodes[i].value=="xst" ){
					if( !starOn ){
						// Click it to remove
						ElSelect.selectedIndex = optionCount;
						GTDGmail_Common.doHtmlEvent(ElSelect, "change");	
					}
					return;
				}
				optionCount++;
			}
		}
		
	},
	
	
	clickHandler_AddRemoveLabel: function(ElLink, addRemove){
		/*
			Retrieve the DropDown (Select)
			Scan the OPTION elements
				Find the one with ac_<labelName>
				Make it selected
				(Simulate click?)
		*/
		
		try{
			labelName = ElLink.getAttribute("item");

			var ElSelect = document.getElementById("ctam");

			GTDGmail_Common.doMouseEvent(ElSelect, 'mouseover');
					
			var optionValue = "";
			if( addRemove=="add" ){
				optionValue = "ac_" + labelName;
			}else{
				optionValue = "rc_" + labelName;
			}
			
			/*	See if we are adding a Status
				If we are, remove all existing statuses.
			*/
			if( addRemove=="add" ){
				if( labelName.indexOf( GTDGmail_Common.SharedObj.LabelTypesObj.Status.prefix )==0 ){
					if( GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.FinishRemovesAllStatusLabels", false) || labelName!=GTDGmail_Common.SharedObj.StandardLabels.Status.Finished ){
							// We're adding a status label (and its not S:Finished), scan all existing and remove
						
						if( labelName==GTDGmail_Common.SharedObj.StandardLabels.Status.NextAction || labelName==GTDGmail_Common.SharedObj.StandardLabels.Status.Action ){
							// It's an action, do not remove actions labels
							this.removeStatusLabels(ElSelect, true);
						}else{
							// Remove all labels
							this.removeStatusLabels(ElSelect);
							
							if( GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.Status.UseStarForNextAction", false) ){
								// We are using Stars for Next Action, therefore remove the star
								this.convoSetStar(false);
							}
						}
						
					}
				}
			}
			
			
			// Loop over children
			var optionCount = 0;
			for( var i = 0; i < ElSelect.childNodes.length; i++ ){
				if( ElSelect.childNodes[i].nodeName.toLowerCase()=="option" ){
					if( ElSelect.childNodes[i].value==optionValue ){
						// We have a match, make it the selected option
						
						ElSelect.selectedIndex = optionCount;
						GTDGmail_Common.doHtmlEvent(ElSelect, "change");					
					}
					optionCount++;
				}
			}
			
			// See if Archive:
			if( addRemove=="add" ){
				if(labelName==GTDGmail_Common.SharedObj.StandardLabels.Status.Finished){
					if( GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.FinishMoveToArchive", false) ){

						setTimeout("GTDGmail_EmailConversationScreen.archiveIt();", 1500);

					}
				}		
			}
			
			this.handleMailConversation(true);
		}catch(e){
			//alert(e.toString());
		}
	},
	archiveIt: function(){
			// Get the button, simulate a link
			ElButtArchive = document.getElementById("ac_rc_^i");
			GTDGmail_Common.doClickEvent(ElButtArchive);
	},
	
	
	removeStatusLabels: function(ElSelect, leaveActionsIntact){
		// Remove the status labels from the conversation
		
		var optionCount = 0;
		var canRemove = false;
		var labelNextAction = "rc_" + GTDGmail_Common.SharedObj.StandardLabels.Status.NextAction;
		var labelAction = "rc_" + GTDGmail_Common.SharedObj.StandardLabels.Status.Action;
		
		for( var i = 0; i < ElSelect.childNodes.length; i++ ){
			if( ElSelect.childNodes[i].nodeName.toLowerCase()=="option" ){
				if( ElSelect.childNodes[i].value.indexOf( "rc_" + GTDGmail_Common.SharedObj.LabelTypesObj.Status.prefix )==0 ){
					// We have a status we can remove.
					
					canRemove = true;
					if( leaveActionsIntact ){
						if( ElSelect.childNodes[i].value==labelNextAction ){
							canRemove = false;
						}
						if( ElSelect.childNodes[i].value==labelAction ){
							canRemove = false;
						}
					}
					if( canRemove ){
						ElSelect.selectedIndex = optionCount;
						GTDGmail_Common.doHtmlEvent(ElSelect, "change");					
					}
				}
				optionCount++;
			}
		}
	},
	
}