


var GTDGmail_Popup_Label = {
	ElTdCurrent: null,
	
	pageHasInbox: function(){
		var ElInbox = document.getElementById("tb");
		var ElFirstItem = document.getElementById("w_0");
		
		if( ElInbox && ElFirstItem ){
			return true;
		}else{
			return false;
		}	
	},
	
	
	handleInbox: function(){
		try{
			this.createPopupBox();
			this.hookInToInboxRows();

		}catch(e){
			//alert(e.toString());
		}
		
		
		/*
		if( this.pageHasInbox() && bool_keepRefreshing ){
			// Propogate the update!
			setTimeout( "GTDGmail_Popup_Label.handleInbox(true)", 8000 );
		}
		*/
	},
	
	
	createPopupBox: function(){
		/*
			Create (or retrieve) a DIV box on the document.body
			Make it hidden
			
			For each label type, add a link to all labels, + a click handler that will add it
		*/
		var ElInbox = document.getElementById("tb");
		
		var ElPopup = document.getElementById("GTD_Popup_Label_Box");
		
		if( ElPopup  ){
			// Do not refresh while available
			return;
		}
		
		if( !ElPopup ){
			ElPopup = document.createElement("DIV");
			ElPopup.id = "GTD_Popup_Label_Box";
			ElPopup.className = "GTD_Popup_Label_Container";
			ElPopup.style.display = "none";
			ElPopup.style.right = "40px";
			if( GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.IncMiscLabels", false) ){
				ElPopup.style.width = "700px";
			}else{
				ElPopup.style.width = "600px";
			}
			
			document.body.appendChild(ElPopup);
		}
		
		//var innerHTML = "<div style='height:2px' onmouseover=\"GTDGmail_Popup_Label.popupHide();\" >&nbsp;</div>";
		//float:right;
		//<div style='height:1px;clear:both;'>&nbsp;</div>
		var innerHTML = "<div style='height:2px;'><div style='height:2px;float:left;width:97%' onmouseover=\"GTDGmail_Popup_Label.popupHide();\">&nbsp;</div><div style='float:right;width:3%;height:2px;' onmouseover=\"\">&nbsp;</div></div>";
		//var innerHTML = "<div style='height:2px' onmouseover=\"alert('yo');\" >&nbsp;</div>";
		//var innerHTML = "<div style='height:2px'><table cellspacing='0' cellpadding='0'><tr><td style='width:90%;' onmouseover=\"GTDGmail_Popup_Label.popupHide();\">&nbsp;</td><td style='width:10%;' onmouseover=\"alert('hi');\">&nbsp;</td></tr></table></div>";
		//innerHTML += "<div style='height:0px;'>&nbsp;</div>";
		innerHTML += "<div style='height:0px;clear:both;'>&nbsp;</div>";
		innerHTML += "<div><div style='float:left;width:3px;display:block;position:relative;' onmouseover=\"GTDGmail_Popup_Label.popupHide();\" >&nbsp;</div><div id='GTD_Popup_Label_Box_Inner'></div></div>";
		innerHTML += "<div style='height:3px' onmouseover=\"GTDGmail_Popup_Label.popupHide();\" >&nbsp;</div>";
		ElPopup.innerHTML = innerHTML;
		
		//var ElPopupInner = document.createElement("DIV");
		var ElPopupInner = document.getElementById("GTD_Popup_Label_Box_Inner");
		ElPopupInner.className = "GTD_Popup_Label_Box";
		
		var innerHTML = "";
		innerHTML += "<div class='GTD_Popup_Label_Header'><strong style='font-size:1.1em;'>Add a GTD Label</strong><span style='position:absolute;right:5px;font-weight:bold;font-family:verdana;color:rgb(204,28,15);' onclick=\"GTDGmail_Popup_Label.popupHide();return false\" >x</span>";
		innerHTML += "<br/><span id='GTD_Popup_Label_Header_Subject'>test</span></div>";
		innerHTML += "<table><tr id='GTD_Popup_Label_TRLabels'></tr></table>";
		ElPopupInner.innerHTML = innerHTML;
		
	},
	
	updatePopupLabelsTable: function(ExcludeLabelsArray){
		if( !ExcludeLabelsArray ){
			ExcludeLabelsArray = new Array();
		}
		
		if( GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.Status.UseStarForNextAction", false) ){
			// Using Stars for Next Action - make sure Next Action label not shown
			ExcludeLabelsArray[ExcludeLabelsArray.length] = GTDGmail_Common.SharedObj.StandardLabels.Status.NextAction;
		}
		
		
		var ElTR_Labels = document.getElementById("GTD_Popup_Label_TRLabels");
		ElTR_Labels.innerHTML = "";
		
		var innerHTML = "";
		// Create Status		
		var linkStr = GTDGmail_Common.renderStandardStatuses_InOrder( "<a id='GTDGmail_Popup_link_Status_<!StatusId!>' href='' onclick=\"GTDGmail_Popup_Label.clickHandler_AddRemoveLabel(this, 'add');return false;\" item=\"<!StatusLabel!>\" ><!StatusLabel!></a><br/>", "", true, ExcludeLabelsArray);
		if( linkStr!="" ){
			// Remove final comma
			linkStr = linkStr.replace(/, $/, "");
			innerHTML += "<td valign='top'><strong>" + GTDGmail_Common.SharedObj.LabelTypesObj.Status.displayName + "</strong><br/>" + linkStr + "</td>";
		}
		// Everything else
		var Types = ["Context", "Project", "Reference", "Misc"];
		for( var i = 0; i < Types.length; i++ ){
			innerHTML += this.getHtml_CreatePopup_LabelLinks(Types[i], ExcludeLabelsArray);
		}
		
		ElTR_Labels.innerHTML = innerHTML;
		
	},
	getHtml_CreatePopup_LabelLinks: function(labelType, ExcludeLabelsArray){
		/*
			For this label type, print the heading of labelType's display name
				Then, for each label in this type, add a link
		*/
		
		var innerHTML = "<strong>" + GTDGmail_Common.SharedObj.LabelTypesObj[labelType].displayName + "</strong><br/>";
		var foundOne = false;
		for( var j = 0; j < GTDGmail_Common.SharedObj.LabelsObj[labelType].LabelArray.length; j++ ){
			var labelStr = GTDGmail_Common.SharedObj.LabelsObj[labelType].LabelArray[j];
			if( !GTDGmail_Common.arrayContains(ExcludeLabelsArray, labelStr) ){
				innerHTML += "<a id='GTDGmail_Popup_link_" + labelType.replace(/[\W]/g, "") + labelStr.replace(/[\W]/g, "") + "' href='' onclick=\"GTDGmail_Popup_Label.clickHandler_AddRemoveLabel(this, 'add');return false;\" item=\"" + labelStr + "\" >" + labelStr + "</a><br/>";
				foundOne = true;
			}
		}
		
		if( foundOne ){
			if( labelType=="Misc" ){
				return "<td valign='top'><div class='GTDMisc'>" + innerHTML + "</div></td>";
			}else{
				return "<td valign='top'>" + innerHTML + "</td>";
			}
		}else{
			return "";
		}
	},
	
	hookInToInboxRows: function(){
		/*
			Grab the first inbox item (w_0)
			Using it's parent node, run over all childen that have ID in the form (w_)
			For each,
				Add a TD with text/logo, that has a mouseover/mouseout property linked to show/hide
		*/
		
		if( document.getElementById("w_0_GTDLabel") ){
			// Already done
			return;
		}
		
		var ElFirstItem = document.getElementById("w_0");
		var ElInbox = ElFirstItem.parentNode;
		
		var statusPrefix = GTDGmail_Common.SharedObj.LabelTypesObj.Status.prefix;
		
		var tdItem = "GTD";
		if( GTDGmail_Common.SharedObj.Options.getOption("bool", "Integration.GTDInbox_Td_UseLogo", false) ){
			tdItem = "<img src='chrome://gtdgmail/content/gtd_lineitem.gif'/>";
		}
		
		
		for( var i = 0; i < ElInbox.childNodes.length; i++ ){
			var ElRow = ElInbox.childNodes[i];
			if( ElRow.id.indexOf("w_")!=-1 ){
				// It's a good row
								
				// ADD POPUP LAUNCHER
				var ElTd = document.createElement("TD");
				ElTd.id = ElRow.id + "_GTDLabel";
				ElTd.style.width = "4ex";
				ElTd.style.position = "relative";
				ElTd.innerHTML = "<div style='float:left;width:2px;top:-2px;' onmouseover=\"GTDGmail_Popup_Label.popupShow(event,this.parentNode)\" >&nbsp;</div><div onmouseover='GTDGmail_Popup_Label.popupShow(event,this.parentNode)' onmouseout='GTDGmail_Popup_Label.popupHide();'>" + tdItem + "</div>"; 
				
				ElRow.appendChild(ElTd);
								
				// UPDATE EACH EXISTING LABEL
				var ElSubject = ElRow.childNodes[4].firstChild;
				if( ElSubject.className=="ct" ){
					// The contents of this node contain the labels; comma seperated
					var LabelArray = ElSubject.innerHTML.split(", ");
					var newLabelsStr = "";
					for( var j = 0; j < LabelArray.length; j++ ){
						//Add x:
						//newLabelsStr += LabelArray[j] + " <a href='' onclick=\"GTDGmail_Popup_Label.clickHandler_AddRemoveLabel('add', '" + LabelArray[j] + "', this.parentNode.parentNode);return false;\" style='color:rgb(204,28,15);font-family:verdana;'>x</a>";
						
						/*
						// If next action, make it bold:
						if( LabelArray[j]==GTDGmail_Common.SharedObj.StandardLabels.Status.NextAction ){
							LabelArray[j] = "<strong>" + LabelArray[j] + "</strong>";
						}
						*/
						// Move Status forward:
						if( LabelArray[j].indexOf( statusPrefix )==0 || LabelArray[j].indexOf( "<str" )!=-1 ){
							// We have status prefix, move it to the front
							if( j > 0 ){
								// Multiple items
								newLabelsStr = LabelArray[j] + ", " + newLabelsStr;
							}else{
								newLabelsStr = LabelArray[j];
							}
						}else{
							// No Status prefix
							if( j > 0 ){
								newLabelsStr += ", ";
							}
							newLabelsStr += LabelArray[j];
						}
					}
					ElSubject.innerHTML = newLabelsStr;
				}
				
				
							
			}
		}
		
		
		
	},
	
	
	
	
	
	popupShow: function(event, ElTd){
		try{			
			var ElPopup = document.getElementById("GTD_Popup_Label_Box");
			
			
			if( ElTd ){
				if( this.ElTdCurrent && this.ElTdCurrent.id==ElTd.id ){
					// Not changed Elements
					if( ElPopup.style.display!="none" ){
						// Already showing it
						return;
					}
				}		
				this.ElTdCurrent = ElTd;
			}
			
			// Get the subject
			var ElTdSubject = this.ElTdCurrent.parentNode.childNodes[4];
			var ElTdSubjectLabels = null;
			var subject = ElTdSubject.innerHTML;
			if( ElTdSubject.firstChild.className=="ct" ){
				ElTdSubjectLabels = ElTdSubject.firstChild;
				subject = subject.replace( ElTdSubjectLabels.innerHTML, "");	// Strip out labels
			}
			
			subject = subject.replace(/\<([^>]+)\>/g, "");
			subject = subject.replace(/- ([^$]+)$/, "");
			var ElGtdBoxSubject = document.getElementById("GTD_Popup_Label_Header_Subject");
			ElGtdBoxSubject.innerHTML = subject;
			
			// Update the Labels Table:
			var ExcludeLabelsArray = null;
			if( ElTdSubjectLabels ){
				ExcludeLabelsArray = ElTdSubjectLabels.innerHTML.split(", ");
			}
			this.updatePopupLabelsTable(ExcludeLabelsArray);
			
			//var elPopupWidth = ElPopup.style.width;
			//elPopupWidth = elPopupWidth.replace(/[\D]/g, "");
			
			ElPopup.style.display = "";
					
			//ElPopup.style.left = (event.clientX - elPopupWidth) - 10;
			//ElPopup.style.top = event.clientY;
			//this.ElTdCurrent.appendChild( ElPopup );
			this.ElTdCurrent.insertBefore( ElPopup, this.ElTdCurrent.firstChild );
			
			
		}catch(e){
			//alert(e.toString());
		}
	},
	
	
	popupHide: function(){
		try{
			this.ElTdCurrent = null;
			
			var ElPopup = document.getElementById("GTD_Popup_Label_Box");
			ElPopup.style.display = "none";
			
		}catch(e){
			//alert(e.toString());
		}
	},
	
	
	
	
	clickHandler_AddRemoveLabel: function(ElLink, addRemove, ElTd){

		var labelId = ElLink.getAttribute("item");
		if( !ElTd ){
			ElTd = this.ElTdCurrent;
		}
		
		try{
			var elTrId = ElTd.parentNode.id;
			var subject = ElTd.parentNode.childNodes[2].innerHTML;
			subject = subject.replace(/\"/g, "");		
			subject = subject.replace(/\'/g, "");
		}catch(e){
			//alert(e.toString());
		}

		// Uncheck all previous:
		try{
			var ElFirstItem = document.getElementById("w_0");
			var ElInbox = ElFirstItem.parentNode;
	
			for( var i = 0; i < ElInbox.childNodes.length; i++ ){
				var ElRow = ElInbox.childNodes[i];
				if( ElRow.id.indexOf("w_")!=-1 ){
					ElRow.firstChild.firstChild.checked = false;
				}
			}
			
		}catch(e){
			//alert(e.toString());
		}


		try{
			// Check boxes:
			var ElCheckbox = ElTd.parentNode.firstChild.firstChild;
			ElCheckbox.checked = true;

			// Apply Label
			var ElSelect = document.getElementById("tam");

			GTDGmail_Common.doMouseEvent(ElSelect, 'mouseover');
					
			var optionValue = "";
			if( addRemove.toLowerCase()=="remove" ){
				optionValue = "rc_" + labelId;
			}else{
				optionValue = "ac_" + labelId;
			}
			
			
			// Loop over children
			var optionCount = 0;
			for( var i = 0; i < ElSelect.childNodes.length; i++ ){
				if( ElSelect.childNodes[i].nodeName.toLowerCase()=="option" ){
					if( ElSelect.childNodes[i].value==optionValue ){
						// We have a match, make it the selected option
						
						ElSelect.selectedIndex = optionCount;
						GTDGmail_Common.doHtmlEvent(ElSelect, "change");					
					}
					optionCount++;
				}
			}


		}catch(e){
			//alert(e.toString());
		}
		
		this.popupHide();
		
		



		setTimeout( "GTDGmail_Popup_Label.handleInbox(false);GTDGmail_Popup_Label.archiveCurrentItem('" + labelId + "', '" + elTrId + "', '" + subject + "')", 2000 );
	},
	archiveCurrentItem: function(labelId, elTrId, subject){
		//alert("0");
		try{
			if(labelId==GTDGmail_Common.SharedObj.StandardLabels.Status.Finished){
				if( GTDGmail_Common.SharedObj.Options.getOption("bool", "GTDGmail.FinishMoveToArchive", false) ){
					//alert("a");
					// Find the correct row
					var ElTr = document.getElementById(elTrId);
						var newSubject = ElTr.childNodes[2].innerHTML;
						newSubject = newSubject.replace(/\"/g, "");		
						newSubject = newSubject.replace(/\'/g, "");
						if( subject==newSubject ){
							//alert("b");
							// Mark it as checked:
							var ElCheckbox = ElTr.firstChild.firstChild;
							ElCheckbox.checked = true;
							// Get the button, simulate a link
							ElButtArchive = document.getElementById("ac_rc_^i");
							GTDGmail_Common.doClickEvent(ElButtArchive);
						}
				}
			}		
		}catch(e){
			//alert(e.toString());
		}
	},


}

