/*

	Gtd Gmail
	(c) 2005 2006 Andy Mitchell [andy@gtdgmail.com]


	This code is covered by the GPL.

	My only additional terms are:

	If you utilise this code directly, please credit 'Andy Mitchell [andy@gtdgmail.com]'
	It is also a requirement to place the url, http://www.gtdgmail.com, somewhere within a public, easily accessible document (E.g. help) that ships with the sugtdequent product.
	If this code gives inspiration to your work, you may optionally wish to credit as such; 
		along with a description of what you improved and why.
		Feel free to also drop an email: I'm always interested in new projects.

*/




/*
	Object to efficiently get/set various Gtd Gmail options.
*/

var GtdGmailOptions = function()
{

	try{
		this.prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	}
	catch(e){
		// Could not load it:
	}


	this.getOption = function(prefType, prefKey, prefDefault){
		/*
			Retrieve an option
		*/
		
		try{
			switch(prefType){
				case "bool":
					return this.prefService.getBoolPref(prefKey);
				case "int":
					return this.prefService.getIntPref(prefKey);
				default:
					return this.prefService.getCharPref(prefKey);
			}
		}
		catch(e){
			return prefDefault;
		}
	}

	this.setOption = function(prefType, prefKey, prefValue){
		/*
			Set an option
		*/
		
		
		try{
			switch(prefType){
				case "bool":
					this.prefService.setBoolPref(prefKey, prefValue);
					break;
				case "int":
					this.prefService.setIntPref(prefKey, prefValue);
					break;
				default:
					this.prefService.setCharPref(prefKey, prefValue);
					break;
			}
		}
		catch(e){}
	}
	
	
	

}
